Package: yahpogym
Type: Package
Title: Interface to the YAHPO Gym python module
Version: 1.0.2
Authors@R:
    c(
        person(
            given = "Florian",
            family = "Pfisterer",
            role = c("cre", "aut"),
            email = "florian.pfisterer@stat.uni-muenchen.de"
        ),
        person(
            given = "Lennart",
            family = "Schneider",
            role = "aut",
            email = "lennart.sch@web.de"
        ))
Description:
    Exposes YAHPO Gym's objective function and parameter space for R.
License: Apache License (== 2.0)
Encoding: UTF-8
Depends:
    R (>= 3.5)
Imports:
    bbotk (>= 1.0.0),
    checkmate (>= 2.0.0),
    mlr3misc (>= 0.1.1),
    paradox (>= 1.0.0),
    reticulate (>= 1.10),
    data.table,
    R6
Suggests:
    testthat,
    withr,
    future
RoxygenNote: 7.3.2
Config/testthat/edition: 3
Config/testthat/parallel: true

<img src="docs/images/carps_Logo_wide.png" alt="Logo"/>

# CARP-S
Welcome to CARP-S! 
This repository contains a benchmarking framework for optimizers.
It allows flexibly combining optimizers and benchmarks via a simple interface, and logging experiment results 
and trajectories to a database.
carps can launch experiment runs in parallel by using [hydra](https://hydra.cc), which offers launchers for slurm/submitit, Ray, RQ, and joblib.

The main topics of this README are:
- [Installation](#installation)
- [Minimal Example](#minimal-example)
- [Commands](#commands)
- [Adding a new Optimizer or Benchmark](#adding-a-new-optimizer-or-benchmark)

For more details on CARP-S, please have a look at the 
[documentation](https://AutoML.github.io/CARP-S/latest/) or our [blog post](https://automl.space/carps-a-framework-for-comparing-n-hyperparameter-optimizers-on-m-benchmarks/).

## Installation

### Installation from PyPI

To install CARP-S, you can simply use `pip`:

1. Create virtual env with conda or uv

```bash
# Conda
conda create -n carps python=3.12
conda activate carps

# -OR -

# uv
pip install uv
export PIP="uv pip"  # Env var needed for Makefile commands
uv venv --python=3.12 carpsenv
source carpsenv/bin/activate
```

2. Install  carps.
```bash
pip install carps
```
### Installation from Source

If you want to install from source, you can clone the repository and install CARP-S via:

#### Conda
```bash
git clone https://github.com/AutoML/CARP-S.git
cd CARP-S
export PIP="pip"
conda create -n carps python=3.12
conda activate carps

# Install for usage
$PIP install .
```

#### uv
```bash
git clone https://github.com/AutoML/CARP-S.git
cd CARP-S
pip install uv
export PIP="uv pip"
uv venv --python=3.12 carpsenv
source carpsenv/bin/activate

# Install for usage
$PIP install .

# Install as editable
$PIP install -e .
```

If you want to install CARP-S for development, you can use the following command (from the root of the repo):
```bash
$PIP install -e .
python -m carps.build.make install-dev
```
#### Apptainer
⚠ This is still experimental.
You can also use a container as an env, see
[this guide](https://automl.github.io/CARP-S/latest/installation/#apptainer).

#### A note on python versions
For python3.12, numpy should be `numpy>=2.0.0`. For python3.10, numpy must be `numpy==1.26.4`, you can simply
`pip install numpy==1.26.4` after running the proposed install commands.

### Installing Benchmarks and Optimizers

Additionally, you need to install the requirements for the benchmark and optimizer that you want to use.

⚠ You can specify the directory of the task data by `export CARPS_TASK_DATA_DIR=...`. Please use absolute dirnames.
The default location is `<carps package location>/task_data`. If you specify a custom dir, always export the env var.
(The carps package location is the root of the package, not of the repo.)

For example, if you want to use the `SMAC3` optimizer and the `BBOB` benchmark, you need to install the
requirements for both of them via:

```bash
# Install options for optimizers and benchmarks (these are Makefile commands, check the Makefile at carps/build for
# more commands)
# The commands should be separated by a whitespace
python -m carps.build.make benchmark_bbob optimizer_smac
```
The benchmarks and optimizers can all be installed in one environment (tested with python3.12).

All possible install options for benchmarks are:
```
benchmark_bbob benchmark_hpobench benchmark_hpob benchmark_mfpbench benchmark_pymoo benchmark_yahpo
```
⚠ Some benchmarks require to download surrogate models and/or containers and thus might take disk space and time to
download.

All possible install options for optimizers are:
```
optimizer_smac optimizer_dehb optimizer_nevergrad optimizer_optuna optimizer_ax optimizer_skopt optimizer_synetune
```
All of the above except `optimizer_hebo` work with python3.12.

You can also install all benchmarks in one go with `benchmarks` and all optimizers with `optimizers`.
Check the `carps/build/Makefile` in carps for more details.


## Minimal Example
Once the requirements for both an optimizer and a benchmark, e.g. `SMAC2.0` and `BBOB`, are installed, you can run
one of the following minimal examples to benchmark `SMAC2.0` on `BBOB` directly with Hydra:

```bash
# Run SMAC BlackBoxFacade on certain BBOB task
python -m carps.run +optimizer/smac20=blackbox +task/BBOB=cfg_4_1_0 seed=1 task.optimization_resources.n_trials=25

# Run SMAC BlackBoxFacade on all available BBOB tasks for 10 seeds
python -m carps.run +optimizer/smac20=blackbox '+task/BBOB=glob(*)' 'seed=range(1,11)' -m
```

For the second command, the Hydra -m (or --multirun) option indicates that multiple runs will be 
performed over a range of parameter values. In this case, it's indicating that the benchmarking
should be run for all available BBOB tasks (`+task/BBOB=glob(*)`) and for 10 different 
seed values (seed=range(1,11)).

## Commands
For a complete list see the [docs](https://automl.github.io/CARP-S/latest/commands/).

You can run a certain task and optimizer combination directly with Hydra via:
```bash
python -m carps.run +task=... +optimizer=... seed=... -m
```

To check whether any runs are missing, you can use the following command. It will create
a file `runcommands_missing.sh` containing the missing runs:
```bash
python -m carps.utils.check_missing <rundir>
```

To collect all run data generated by the file logger into parquet files, use the following command:
```bash
python -m carps.analysis.gather_data <rundir>
```
The parquet files are then located in `<rundir>`. `logs.parquet` contain the trial info and values and 
`logs_cfg.parquet` contain the experiment  configuration.
The experiments can be matched via the column `experiment_id`.

## CARPS and MySQL Database
Per default, `carps` logs to files. This has its caveats: Checking experiment status is a bit more cumbersome (but 
possible with `python -m carps.utils.check_missing <rundir>` to check for missing/failed experiments) and reading from
the filesystem takes a long time. For this reason, we can also control and log experiments to a MySQL database with
`PyExperimenter`. See the
[guide in the docs](https://automl.github.io/CARP-S/latest/guides/database/) for information
about how to set it up.

## Adding a new Optimizer or Benchmark
For instructions on how to add a new optimizer or benchmark, please refer to the contributing 
guidelines for 
[benchmarks](https://automl.github.io/CARP-S/latest/contributing/contributing-a-benchmark/)
and
[optimizers](https://automl.github.io/CARP-S/latest/contributing/contributing-an-optimizer/).

## Using your (external) optimizer or benchmark
In the case when you are developing your optimizer or benchmark in a standalone package, you can use carps without directly working in the carps repo.
For a custom benchmark we have an [example repo](https://github.com/automl/OptBench).
It shows how to use your own benchmark with carps optimizers.
For a custom optimizer check this [example repo](https://github.com/automl/CARP-S-example-optimizer).
Information is also available [here](https://automl.github.io/CARP-S/guides/using-carps/).

## Evaluation Results
For each task_type (blackbox, multi-fidelity, multi-objective and multi-fidelity-multi-objective) and set (dev and test), we run selected optimizers and provide the data.
Here we provide the link to the [meta data](https://drive.google.com/file/d/1Z9qcJDUb2jrZeC1qcgc4ByNUKAtOw6dX/view?usp=sharing) 
that contains the detailed optimization setting for each run  
and the [running results](https://drive.google.com/file/d/1Ai-pM_LlsQ0E4EAfkeujtu6iwvhozhda/view?usp=sharing) that 
records the running results of each optimization-benchmark combination. 

# YAHPO Gym
[![Unittests](https://github.com/slds-lmu/yahpo_gym/actions/workflows/unittests_gym_py.yml/badge.svg?branch=main)](https://github.com/slds-lmu/yahpo_gym/actions)
[![Docs](https://github.com/slds-lmu/yahpo_gym/actions/workflows/docs.yml/badge.svg?branch=main)](https://github.com/slds-lmu/yahpo_gym/actions)
[![Module Handbook](https://img.shields.io/badge/Website-Documentation-blue)](https://slds-lmu.github.io/yahpo_gym/)
[![Paper](https://img.shields.io/badge/arXiv-Paper-blue)](https://arxiv.org/abs/2109.03670)
[![Software (Python)](https://img.shields.io/badge/Software-Python-green)](https://github.com/slds-lmu/yahpo_gym/tree/main/yahpo_gym)
[![Software (R)](https://img.shields.io/badge/Software-R-green)](https://github.com/slds-lmu/yahpo_gym/tree/main/yahpo_gym_r)

### What is YAHPO Gym?

**YAHPO Gym** (Yet Another Hyperparameter Optimization Gym) is a collection of interesting problem sets for benchmark hyperparameter optimization / black-box optimization methods described in [this paper](https://arxiv.org/abs/2109.03670).
The underlying software with additional documentation and background can be found [here](https://github.com/slds-lmu/yahpo_gym/tree/main/yahpo_gym).
See the [module Documentation](https://slds-lmu.github.io/yahpo_gym/) for more info.

- **Problem Variety**: Optimization problems in YAHPO Gym stem from diverse Hyperparameter Optimization scenarios on tabular as well as image data.
- **Multi-Fidelity**: Allows for simulating low-fidelity approximations to the real target values to simulate multi-fidelity HPO.
- **Multi-Objective**: Benchmarks usually contain multiple objectives: performance metrics, runtime and memory consumption allowing for multi-objective and resource aware HPO.

YAHPO Gym distinguishes between `scenarios` and `instances`.
A `scenario` is a collection of `instances` that share the same hyperparameter space. In practice, a `scenario` usually consists of a single algorithm optimized on a variety of datasets (= `instances`).

This repository contains three modules/packages:

- `yahpo_gym` (python): The core package allowing for inference on the surrogates.
- `yahpo_train` (python): Module for training surrogate models used in `yahpo_gym`.
- `yahpo_gym_r`(R): An R wrapper for `yahpo_gym`.

We also maintain a list of [frequently asked questions](https://slds-lmu.github.io/yahpo_gym/frequently_asked.html).

**NEWS:**

- The [paper](https://proceedings.mlr.press/v188/pfisterer22a.html) accompanying `YAHPO Gym` was accepted at the 1st International Conference on Automated Machine Learning!
- YAHPO Gym (python) can now be installed via `pip install yahpo-gym`
- YAHPO Gym is now available in [HPOBench](https://github.com/automl/HPOBench/)
- YAHPO Gym is now available in [syne-tune](https://github.com/awslabs/syne-tune)

### Why should I use it?

**YAHPO Gym** (Yet Another Hyperparameter Optimization Gym) provides blazing fast and simple access to a variety of interesting benchmark problems for hyperparameter optimization.
Since all our benchmarks are based on surrogate models that approximate the underlying HPO problems with very high fidelity, function evaluations are fast and memory friendly allowing for fast benchmarks
across a large variety of problems.

![image](https://github.com/slds-lmu/yahpo_gym/blob/main/assets/anytime_average_rank_mf.jpg?raw=true)

**Overview over benchmark instances**

|Scenario    |Search Space    |# Instances|Target Metrics                       |Fidelity| H|     Source|
|:-----------|---------------:|----------:|------------------------------------:|:-------|-:|----------:|
|rbv2_super  |38D: Mixed      |        103| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|rbv2_svm    | 6D: Mixed      |        106| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|rbv2_rpart  | 5D: Mixed      |        117| 9: perf(6) + rt(2) + mem            |fraction|  |        [1]|
|rbv2_aknn   | 6D: Mixed      |        118| 9: perf(6) + rt(2) + mem            |fraction|  |        [1]|
|rbv2_glmnet | 3D: Mixed      |        115| 9: perf(6) + rt(2) + mem            |fraction|  |        [1]|
|rbv2_ranger | 8D: Mixed      |        119| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|rbv2_xgboost|14D: Mixed      |        119| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|nb301       |34D: Categorical|          1| 2: perf(1) + rt(1)                  |epoch   | ✓|   [2], [3]|
|lcbench     | 7D: Numeric    |         34| 6: perf(5) + rt(1)                  |epoch   |  |   [4], [5]|
|iaml_super  |28D: Mixed      |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction| ✓|        [6]|
|iaml_rpart  | 4D: Numeric    |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction|  |        [6]|
|iaml_glmnet | 2D: Numeric    |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction|  |        [6]|
|iaml_ranger | 8D: Mixed      |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction| ✓|        [6]|
|iaml_xgboost|13D: Mixed      |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction| ✓|        [6]|

The **full, up-to-date overview** can be obtained from the [Documentation](https://slds-lmu.github.io/yahpo_gym/scenarios.html).
The fidelity is given either as the dataset fraction `fraction` or the number of epochs `epoch`.
Search spaces can be numeric, mixed and have dependencies (as indicated in the `H` column).

Original data sources are given by:

- [1] Binder M., Pfisterer F. & Bischl B. (2020). Collecting Empirical Data About Hyperparameters for Data Driven AutoML. 7th ICML Workshop on Automated Machine Learning.
- [2] Siems, J., Zimmer, L., Zela, A., Lukasik, J., Keuper, M., & Hutter, F. (2020). NAS-Bench-301 and the Case for Surrogate Benchmarks for Neural Architecture Search. arXiv preprint arXiv:2008.09777, 11.
- [3] Zimmer, L. (2020). nasbench301_full_data. figshare. Dataset. https://doi.org/10.6084/m9.figshare.13286105.v1, Apache License, Version 2.0.
- [4] Zimmer, L., Lindauer, M., & Hutter, F. (2021). Auto-Pytorch: Multi-Fidelity Metalearning for Efficient and Robust AutoDL. IEEE Transactions on Pattern Analysis and Machine Intelligence, 43(9), 3079-3090.
- [5] Zimmer, L. (2020). data_2k_lw.zip. figshare. Dataset. https://doi.org/10.6084/m9.figshare.11662422.v1, Apache License, Version 2.0.
- [6] None, simply cite Pfisterer, F., Schneider, L., Moosbauer, J., Binder, M., & Bischl, B. (2022). YAHPO Gym - An Efficient Multi-Objective Multi-Fidelity Benchmark for Hyperparameter Optimization. In International Conference on Automated Machine Learning.

**Please make sure to always also cite the original data sources as YAHPO Gym would not have been possible without them!**

### What does this repository contain?

This repository contains two modules: `yahpo_gym` and `yahpo_train`.
While we mainly focus on `yahpo_gym`, as it is provides an interface to the benchmark described in our [paper](https://arxiv.org/abs/2109.03670),
we also provide the full reproducible codebase used to generate the underlying surrogate neural networks in `yahpo_train`.

#### YAHPO Gym

YAHPO Gym is the module for inference and allows for evaluating a HPC configuration on a given benchmark instance.

Surrogate models (ONNX files), configspaces and metadata (encoding) can be obtained [here (Github)](https://github.com/slds-lmu/yahpo_data).

An example for evaluation and running HPO methods is given in the README of the [YAHPO Gym module](https://github.com/slds-lmu/yahpo_gym/tree/main/yahpo_gym).

A quick introduction is given in the accompanying [jupyter notebook](https://github.com/slds-lmu/yahpo_gym/blob/main/yahpo_gym/notebooks/using_yahpo_gym.ipynb).

#### YAHPO Train

YAHPO Train is the module for training new surrogate models.

YAHPO Train is still in a preliminary state but can already be used to reproduce and refit models introduced in our [paper](https://arxiv.org/abs/2109.03670).

#### Docker

A `docker` image that allows accessing `yahpo_gym` is available from `DockerHub` at [pfistfl/yahpo](https://hub.docker.com/repository/docker/pfistfl/yahpo/general). This adds additional overhead but simplifies use and installation. 
The corresponding dockerfile to get you started can be found in `docker/`.

#### Roadmap

We want to add several features to **yahpo_gym** in future versions:

- **Asynchronous Evaluation**
  We would like to allow for faster-than-realtime asynchronous evaluation in future versions. This is currently available as an experimental feature via `objective_function_timed`, but requires additional (experimental) evaluation for release.
- **Noisy Surrogate Models**
  We would like to allow for surrogates that more closely reflect the underlying (noisy) nature of real HPO experiments. Currently, noisy evaluation are available using `noisy = True` during instantiation, but this feature is considered experimental and
  requires additional evaluation for release.
- **Additional Scenarios**
  We are always happy to include additional (interesting) scenarios. If you know of (or want to add) an additional scenario, get in touch!

  We welcome input, discussion or additions by the broader community. Get in touch via issues or emails if you have questions, comments or would like to collaborate!

#### Related Software

- [rbv2](https://github.com/pfistfl/rbv2) (R-Package) can be used to reproduce runs from all `rbv2_*` in a real setting.
- [iaml](https://github.com/sumny/iaml) (R-Package) can be used to reproduce runs from all `iaml_*` in a real setting.

### Citation

If you use YAHPO Gym, please cite the following paper:

- Pfisterer, F., Schneider, L., Moosbauer, J., Binder, M., & Bischl, B. (2022). YAHPO Gym - An Efficient Multi-Objective Multi-Fidelity Benchmark for Hyperparameter Optimization. In International Conference on Automated Machine Learning.

Moreover, certain `scenarios` built upon previous work, e.g., the `lcbench` scenario uses data from:

- Zimmer, L., Lindauer, M., & Hutter, F. (2021). Auto-Pytorch: Multi-Fidelity Metalearning for Efficient and Robust AutoDL. IEEE Transactions on Pattern Analysis and Machine Intelligence, 43(9), 3079-3090.
- Zimmer, L. (2020). data_2k_lw.zip. figshare. Dataset. https://doi.org/10.6084/m9.figshare.11662422.v1, Apache License, Version 2.0.

**Please make sure to always also cite the original data sources as YAHPO Gym would not have been possible without them!**

Original data sources of a scenario that should also be cited are provided via the `"citation"` key within the `config` dictionary of a scenario, e.g.:

```py
from yahpo_gym.configuration import cfg
lcbench = cfg("lcbench")
lcbench.config.get("citation")
```

# HPOBench

HPOBench is a library for providing benchmarks for (multi-fidelity) hyperparameter optimization and with a focus on reproducibility.

Further info:
  * list of [benchmarks](https://github.com/automl/HPOBench/wiki/Available-Containerized-Benchmarks)
  * [howto](https://github.com/automl/HPOBench/wiki/How-to-add-a-new-benchmark-step-by-step) contribute benchmarks

## Status

Status for Master Branch: 
[![Build Status](https://github.com/automl/HPOBench/workflows/Test%20Pull%20Requests/badge.svg?branch=master)](https://github.com/automl/HPOBench/actions)
[![codecov](https://codecov.io/gh/automl/HPOBench/branch/master/graph/badge.svg)](https://codecov.io/gh/automl/HPOBench)

Status for Development Branch: 
[![Build Status](https://github.com/automl/HPOBench/workflows/Test%20Pull%20Requests/badge.svg?branch=development)](https://github.com/automl/HPOBench/actions)
[![codecov](https://codecov.io/gh/automl/HPOBench/branch/development/graph/badge.svg)](https://codecov.io/gh/automl/HPOBench)

## In 4 lines of code

Evaluate a random configuration using a singularity container
```python
from hpobench.container.benchmarks.nas.tabular_benchmarks import SliceLocalizationBenchmark
b = SliceLocalizationBenchmark(rng=1)
config = b.get_configuration_space(seed=1).sample_configuration()
result_dict = b.objective_function(configuration=config, fidelity={"budget": 100}, rng=1)
```

All benchmarks can also be queried with fewer or no fidelities:

```python
from hpobench.container.benchmarks.nas.tabular_benchmarks import SliceLocalizationBenchmark
b = SliceLocalizationBenchmark(rng=1)
config = b.get_configuration_space(seed=1).sample_configuration()
result_dict = b.objective_function(configuration=config, fidelity={"budget": 50}, rng=1)
# returns results on the highest budget
result_dict = b.objective_function(configuration=config, rng=1)
```

For each benchmark further info on the searchspace and fidelity space can be obtained:

```python
from hpobench.container.benchmarks.nas.tabular_benchmarks import SliceLocalizationBenchmark
b = SliceLocalizationBenchmark(task_id=167149, rng=1)
cs = b.get_configuration_space(seed=1)
fs = b.get_fidelity_space(seed=1)
meta = b.get_meta_information()
```

## Installation

We recommend using a virtual environment. To install HPOBench, please run the following:
```
git clone https://github.com/automl/HPOBench.git
cd HPOBench 
pip install .
```

**Note:** This does not install *singularity (version 3.6)*. Please follow the steps described here: [user-guide](https://sylabs.io/guides/3.6/user-guide/quick_start.html#quick-installation-steps).   
If you run into problems, using the most recent singularity version might help: [here](https://singularity.hpcng.org/admin-docs/master/installation.html)

## Containerized Benchmarks

We provide all benchmarks as containerized versions to (i) isolate their dependencies and (ii) keep them reproducible. Our containerized benchmarks do not rely on external dependencies and thus do not change over time. For this, we rely on [Singularity (version 3.6)](https://sylabs.io/guides/3.6/user-guide/) and for now upload all containers to a [gitlab registry](https://gitlab.tf.uni-freiburg.de/muelleph/hpobench-registry/container_registry)

The only other requirements are: [ConfigSpace](https://github.com/automl/ConfigSpace), *scipy* and *numpy* 

### Run a Benchmark Locally

Each benchmark can also be run locally, but the dependencies must be installed manually and might conflict with other benchmarks. This can be arbitrarily complex and further information can be found in the docstring of the benchmark.
 
A simple example is the XGBoost benchmark which can be installed with `pip install .[xgboost]`

```python
from hpobench.benchmarks.ml.xgboost_benchmark_old import XGBoostBenchmark

b = XGBoostBenchmark(task_id=167149)
config = b.get_configuration_space(seed=1).sample_configuration()
result_dict = b.objective_function(configuration=config,
                                   fidelity={"n_estimators": 128, "dataset_fraction": 0.5}, rng=1)

```

### How to Build a Container Locally

With singularity installed run the following to built the, e.g. xgboost container

```bash
cd hpobench/container/recipes/ml
sudo singularity build xgboost_benchmark Singularity.XGBoostBenchmark
```

You can use this local image with:

```python
from hpobench.container.benchmarks.ml.xgboost_benchmark import XGBoostBenchmark
b = XGBoostBenchmark(task_id=167149, container_name="xgboost_benchmark", 
                     container_source='./') # path to hpobench/container/recipes/ml
config = b.get_configuration_space(seed=1).sample_configuration()
result_dict = b.objective_function(config, fidelity={"n_estimators": 128, "dataset_fraction": 0.5})
```

## Configure HPOBench

All of HPOBench's settings are stored in a file, the `hpobenchrc`-file. It is a .yaml file, which is automatically generated at the first use of HPOBench. 
By default, it is placed in `$XDG_CONFIG_HOME` (or if not set this defaults to `'~/.config/hpobench'`). This file defines where to store containers and datasets and much more. We highly recommend to have a look at this file once it's created. Furthermore, please make sure to have write permission in these directories or adapt if necessary. For more information on where data is stored, please see the section on `HPOBench Data` below.

Furthermore, for running containers, we rely on Unix sockets which by default are located in `$TEMP_DIR` (or if not set this defaults to `\tmp`). 

### Remove all data, containers, and caches

Feel free to use `hpobench/util/clean_up_script.py` to remove all data, downloaded containers and caches:
```bash
python ./hpobench/util/clean_up_script.py --help
``` 

If you like to delete only specific parts, i.e. a single container, you can find the benchmark's data, container, and caches in the following directories:

#### HPOBench Data
HPOBench stores downloaded containers and datasets at the following locations:

```bash
$XDG_CONFIG_HOME # ~/.config/hpobench
$XDG_CACHE_HOME # ~/.cache/hpobench
$XDG_DATA_HOME # ~/.local/share/hpobench
```

For crashes or when not properly shutting down containers, there might be socket files left under `/tmp/hpobench_socket`.

#### OpenML Data

OpenML data additionally maintains its cache which is located at `~/.openml/`

#### Singularity Containers

Singularity additionally maintains its cache which can be removed with `singularity cache clean`

### Use HPOBench Benchmarks in Research Projects

If you use a benchmark in your experiments, please specify the version number of the HPOBench as well as the version of 
the used container to ensure reproducibility. When starting an experiment, HPOBench writes automatically these two version numbers to the log. 

### Troubleshooting and Further Notes

  - **Singularity throws an 'Invalid Image format' exception**
  Use a singularity version > 3. For users of the Meta-Cluster in Freiburg, you have to set the following path:
  ```export PATH=/usr/local/kislurm/singularity-3.5/bin/:$PATH```

  - **A Benchmark fails with `SystemError: Could not start an instance of the benchmark. Retried 5 times` but the container 
can be started locally with `singularity instance start <pathtocontainer> test`**
See whether in `~/.singularity/instances/sing/$HOSTNAME/*/` there is a file that does not end with '}'. If yes delete this file and retry.   

**Note:** If you are looking for a different or older version of our benchmarking library, you might be looking for
 [HPOlib1.5](https://github.com/automl/HPOlib1.5) 
 
## Reference

If you use HPOBench, please cite the following paper:

```bibtex
@inproceedings{
  eggensperger2021hpobench,
  title={{HPOB}ench: A Collection of Reproducible Multi-Fidelity Benchmark Problems for {HPO}},
  author={Katharina Eggensperger and Philipp M{\"u}ller and Neeratyoy Mallik and Matthias Feurer and Rene Sass and Aaron Klein and Noor Awad and Marius Lindauer and Frank Hutter},
  booktitle={Thirty-fifth Conference on Neural Information Processing Systems Datasets and Benchmarks Track (Round 2)},
  year={2021},
  url={https://openreview.net/forum?id=1k4rJYEwda-}
}
```

[![Docker Build](https://github.com/LeoIV/bencher/actions/workflows/docker_build.yml/badge.svg)](https://github.com/LeoIV/bencher/actions/workflows/docker_build.yml)

# Docker Container

The Docker container can be pulled from the [Docker Hub](https://hub.docker.com/r/gaunab/bencher) or built locally.
It contains all benchmarks and dependencies and exposes the benchmark server via port 50051.

We give an exemplary usage of the Docker container in the [bencherclient](https://github.com/LeoIV/bencherclient)
repository.

```shell
pwd # /path/to/bencher
docker build -t bencher .
# always keep the container running, can be stopped with docker stop <container-id>
docker run -p 50051:50051 --restart always -d gaunab/bencher:latest
```

**or**

```shell
docker pull gaunab/bencher:latest
# always keep the container running, can be stopped with docker stop <container-id>
docker run -p 50051:50051 --restart always -d gaunab/bencher:latest
```

# Apptainer / Singularity Container

You can build an Apptainer container from the Docker image:

```shell
Bootstrap: docker
From: gaunab/bencher:latest
Namespace:
Stage: build

%environment
    export LANG=C.UTF-8
    export PATH="/root/.local/bin:$PATH"

%post
    cd /opt
    git clone your-repo
    cd your-repo
    pip install bencherscaffold # you'll need bencherscaffold to call bencher
    pip install your-dependencies

%startscript
    bash -c "/docker-entrypoint.sh"

%runscript
    bash -c "your-command-to-run-your-app"
```

This will create an Apptainer container with the Docker image `gaunab/bencher:latest` and the repository `your-repo`
with the dependencies `your-dependencies` installed.

## Usage

### Starting the instance

```shell
apptainer build container.sif your-apptainer-file
```

### Start the Apptainer instance

This starts all the benchmarks in the container (as defined in the `startscript` of the Apptainer file).

```shell
apptainer instance start container.sif your-instance-name
```

### Run your command that depends on the benchmarks

This runs your command in the instance `your-instance-name` as defined in the `runscript` of the Apptainer file.

```shell
apptainer run instance://your-instance-name
```

### Evaluating a benchmark

We show how to run all benchmarks in the [`bencherclient`](https://github.com/LeoIV/bencherclient) repository.
You don't need to use this repository, it is mainly used to test the benchmarks.
The general setup to evaluate a benchmark is as follows.
First, install the [`bencherscaffold`](https://github.com/LeoIV/BencherScaffold) package:

```shell
pip install git+https://github.com/LeoIV/BencherScaffold
```

Then, you can use the following code to evaluate a benchmark:

```python
from bencherscaffold.client import BencherClient
from bencherscaffold.protoclasses.bencher_pb2 import Value, ValueType

# Create a client to communicate with the Bencher server
# By default, it connects to 127.0.0.1:50051
client = BencherClient()

# Create a list of values to evaluate
values = [Value(type=ValueType.CONTINUOUS, value=0.5) for _ in range(180)]
# The benchmark name is the name of the benchmark you want to evaluate
benchmark_name = 'lasso-dna'

# Evaluate the benchmark with the given values
# This will send the values to the server and return the result
# If the server is not running, it will raise an error
result = client.evaluate_point(
    benchmark_name=benchmark_name,
    point=values,
)
print(f"Result: {result}")
```

### Available Benchmarks

The following benchmarks are available:

| Benchmark Name             | # Dimensions | Type        | Source(s)      | Noisy    |
|----------------------------|--------------|-------------|----------------|----------|
| lasso-dna                  | 180          | continuous  | [^1],[^5]      | &#x2612; |
| lasso-simple               | 60           | continuous  | [^1]           | &#x2612; |
| lasso-medium               | 100          | continuous  | [^1]           | &#x2612; |
| lasso-high                 | 300          | continuous  | [^1],[^5]      | &#x2612; |
| lasso-hard                 | 1000         | continuous  | [^1],[^5]      | &#x2612; |
| lasso-leukemia             | 7129         | continuous  | [^1]           | &#x2612; |
| lasso-rcv1                 | 47236        | continuous  | [^1],[^2]      | &#x2612; |
| lasso-diabetes             | 8            | continuous  | [^1]           | &#x2612; |
| lasso-breastcancer         | 10           | continuous  | [^1]           | &#x2612; |
| mopta08                    | 124          | continuous  | [^4],[^5]      | &#x2612; |
| maxsat60                   | 60           | binary      | [^6],[^7]      | &#x2612; |
| maxsat125                  | 125          | binary      | [^7]           | &#x2612; |
| robotpushing               | 14           | continuous  | [^3]           | &#x2611; |
| lunarlander                | 12           | continuous  | [^3]           | &#x2611; |
| rover                      | 60           | continuous  | [^3]           | &#x2612; |
| mujoco-ant                 | 888          | continuous  | [^9],[^5]      | &#x2611; |
| mujoco-hopper              | 33           | continuous  | [^9],[^5]      | &#x2611; |
| mujoco-walker              | 102          | continuous  | [^9],[^5]      | &#x2611; |
| mujoco-halfcheetah         | 102          | continuous  | [^9],[^5]      | &#x2611; |
| mujoco-swimmer             | 16           | continuous  | [^9],[^5]      | &#x2611; |
| mujoco-humanoid            | 6392         | continuous  | [^9],[^5]      | &#x2611; |
| svm                        | 388          | continuous  | [^4],[^5],[^8] | &#x2612; |
| svmmixed                   | 53           | mixed       | [^6],[^7]      | &#x2612; |
| pestcontrol                | 25           | categorical | [^10],[^13]    | &#x2612; |
| bbob-sphere                | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-ellipsoid             | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-rastrigin             | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-buecherastrigin       | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-linearslope           | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-attractivesector      | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-stepellipsoid         | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-rosenbrock            | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-rosenbrockrotated     | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-ellipsoidrotated      | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-discus                | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-bentcigar             | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-sharpridge            | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-differentpowers       | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-rastriginrotated      | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-weierstrass           | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-schaffers10           | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-schaffers1000         | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-griewankrosenbrock    | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-schwefel              | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-gallagher101          | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-gallagher21           | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-katsuura              | any          | continuous  | [^11],[^12]    | &#x2612; |
| bbob-lunacekbirastrigin    | any          | continuous  | [^11],[^12]    | &#x2612; |
| pbo-onemax                 | any          | binary      | [^11]          | &#x2612; |
| pbo-leadingones            | any          | binary      | [^11]          | &#x2612; |
| pbo-linear                 | any          | binary      | [^11]          | &#x2612; |
| pbo-onemaxdummy1           | any          | binary      | [^11]          | &#x2612; |
| pbo-onemaxdummy2           | any          | binary      | [^11]          | &#x2612; |
| pbo-onemaxneutrality       | any          | binary      | [^11]          | &#x2612; |
| pbo-onemaxepistasis        | any          | binary      | [^11]          | &#x2612; |
| pbo-onemaxruggedness1      | any          | binary      | [^11]          | &#x2612; |
| pbo-onemaxruggedness2      | any          | binary      | [^11]          | &#x2612; |
| pbo-onemaxruggedness3      | any          | binary      | [^11]          | &#x2612; |
| pbo-leadingonesdummy1      | any          | binary      | [^11]          | &#x2612; |
| pbo-leadingonesdummy2      | any          | binary      | [^11]          | &#x2612; |
| pbo-leadingonesneutrality  | any          | binary      | [^11]          | &#x2612; |
| pbo-leadingonesepistasis   | any          | binary      | [^11]          | &#x2612; |
| pbo-leadingonesruggedness1 | any          | binary      | [^11]          | &#x2612; |
| pbo-leadingonesruggedness2 | any          | binary      | [^11]          | &#x2612; |
| pbo-leadingonesruggedness3 | any          | binary      | [^11]          | &#x2612; |
| pbo-labs                   | any          | binary      | [^11]          | &#x2612; |
| pbo-isingring              | any          | binary      | [^11]          | &#x2612; |
| pbo-isingtorus             | any          | binary      | [^11]          | &#x2612; |
| pbo-isingtriangular        | any          | binary      | [^11]          | &#x2612; |
| pbo-mis                    | any          | binary      | [^11]          | &#x2612; |
| pbo-nqueens                | any          | binary      | [^11]          | &#x2612; |
| pbo-concatenatedtrap       | any          | binary      | [^11]          | &#x2612; |
| pbo-nklandscapes           | any          | binary      | [^11]          | &#x2612; |
| graph-maxcut2000           | 800          | binary      | [^11]          | &#x2612; |
| graph-maxcut2001           | 800          | binary      | [^11]          | &#x2612; |
| graph-maxcut2002           | 800          | binary      | [^11]          | &#x2612; |
| graph-maxcut2003           | 800          | binary      | [^11]          | &#x2612; |
| graph-maxcut2004           | 800          | binary      | [^11]          | &#x2612; |
| graph-maxcoverage2100      | 800          | binary      | [^11]          | &#x2612; |
| graph-maxcoverage2101      | 800          | binary      | [^11]          | &#x2612; |

# Citation
If you use this repository or the benchmarks in your research, please cite the following [paper](https://arxiv.org/abs/2505.21321):

```bibtex
@misc{papenmeier2025bencher,
      title={Bencher: Simple and Reproducible Benchmarking for Black-Box Optimization}, 
      author={Leonard Papenmeier and Luigi Nardi},
      year={2025},
      eprint={2505.21321},
      archivePrefix={arXiv},
      primaryClass={cs.LG},
      url={https://arxiv.org/abs/2505.21321}, 
}
```

[^1]: [`LassoBench`](https://github.com/ksehic/LassoBench) (`
Šehić Kenan, Gramfort Alexandre, Salmon Joseph and Nardi Luigi, "LassoBench: A High-Dimensional Hyperparameter Optimization Benchmark Suite for Lasso", AutoML conference, 2022.`)
[^2]: The LassoBench paper states 19,959 features, but the number of features in the RCV1 dataset is 47,236.
[^3]: [`TurBO`](https://github.com/uber-research/TuRBO) (
`David Eriksson, Michael Pearce, Jacob Gardner, Ryan D Turner and Matthias Poloczek, "Scalable Global Optimization via Local Bayesian Optimization." NeurIPS 2019`)
[^4]: [`SAASBO`](https://github.com/martinjankowiak/saasbo)
`David Eriksson and Martin Jankowiak, "High-dimensional Bayesian optimization with sparse axis-aligned subspaces", UAI 2021`
[^5]: [`BAxUS`](https://github.com/LeoIV/BAxUS)
`Leonard Papenmeier, Luigi Nardi, and Matthias Poloczek, "Increasing the Scope as You Learn: Adaptive Bayesian Optimization in Nested Subspaces", NeurIPS 2022`
[^6]: [`BODi`](https://github.com/aryandeshwal/BODi)
`Aryan Deshwal, Sebastian Ament, Maximilian Balandat, Eytan Bakshy, Janardhan Rao Doppa, and David Eriksson, "Bayesian Optimization over High-Dimensional Combinatorial Spaces via Dictionary-based Embeddings", AISTATS 2023`
[^7]: [`Bounce`](https://github.com/LeoIV/bounce)
`Leonard Papenmeier, Luigi Nardi and Matthias Poloczek, "Bounce: Reliable High-Dimensional Bayesian Optimization for Combinatorial and Mixed Spaces", NeurIPS 2023`
[^8]: The SVM benchmark is not included in the repository and was obtained by corresponding with the authors of the
paper.
[^9]: [`LA-MCTS`](https://github.com/facebookresearch/LA-MCTS)
`Linnan Wang, Rodrigo Fonseca, and Yuandong Tian, "Learning Search Space Partition for Black-box Optimization using Monte Carlo Tree Search", NeurIPS 2020`
[^10]: Oh, Changyong, et al. "Combinatorial bayesian optimization using the graph cartesian product." Advances in Neural
Information Processing Systems 32 (2019).
[^11]: de Nobel, Jacob, et al. "Iohexperimenter: Benchmarking platform for iterative optimization heuristics."
Evolutionary Computation 32.3 (2024): 205-210.
[^12]: Hansen, Nikolaus, et al. "COCO: A platform for comparing continuous optimizers in a black-box setting."
Optimization Methods and Software 36.1 (2021): 114-144.
[^13]: Each category has 5 possible values. The benchmark expects an integer between 0 and 4 for each category.

# YAHPO Gym (python)
[![Unittests](https://github.com/slds-lmu/yahpo_gym/actions/workflows/unittests_gym_py.yml/badge.svg?branch=main)](https://github.com/slds-lmu/yahpo_gym/actions)
[![Module Handbook](https://img.shields.io/badge/Website-Documentation-blue)](https://slds-lmu.github.io/yahpo_gym/)
[![Paper](https://img.shields.io/badge/arXiv-Paper-blue)](https://arxiv.org/abs/2109.03670)
[![Software (R)](https://img.shields.io/badge/Software-R-green)](https://github.com/slds-lmu/yahpo_gym/tree/main/yahpo_gym_r)

### What is YAHPO Gym?

**YAHPO Gym** (Yet Another Hyperparameter Optimization Gym) is a collection of interesting problems to benchmark hyperparameter optimization (HPO) methods described in [our paper](https://arxiv.org/abs/2109.03670).
YAHPO Gym consists of several `scenarios`. A scenario (e.g. `lcbench`) is a collection of benchmark instances with the same underlying hyperparameter optimization task (e.g., optimizing the hyperparameters of a neural network) on different datasets (usually taken from [OpenML](https://www.openml.org/)).

**Overview over benchmark instances**

|Scenario    |Search Space    |# Instances|Target Metrics                       |Fidelity| H|     Source|
|:-----------|---------------:|----------:|------------------------------------:|:-------|-:|----------:|
|rbv2_super  |38D: Mixed      |        103| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|rbv2_svm    | 6D: Mixed      |        106| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|rbv2_rpart  | 5D: Mixed      |        117| 9: perf(6) + rt(2) + mem            |fraction|  |        [1]|
|rbv2_aknn   | 6D: Mixed      |        118| 9: perf(6) + rt(2) + mem            |fraction|  |        [1]|
|rbv2_glmnet | 3D: Mixed      |        115| 9: perf(6) + rt(2) + mem            |fraction|  |        [1]|
|rbv2_ranger | 8D: Mixed      |        119| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|rbv2_xgboost|14D: Mixed      |        119| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|nb301       |34D: Categorical|          1| 2: perf(1) + rt(1)                  |epoch   | ✓|   [2], [3]|
|lcbench     | 7D: Numeric    |         34| 6: perf(5) + rt(1)                  |epoch   |  |   [4], [5]|
|iaml_super  |28D: Mixed      |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction| ✓|        [6]|
|iaml_rpart  | 4D: Numeric    |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction|  |        [6]|
|iaml_glmnet | 2D: Numeric    |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction|  |        [6]|
|iaml_ranger | 8D: Mixed      |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction| ✓|        [6]|
|iaml_xgboost|13D: Mixed      |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction| ✓|        [6]|

The **full, up-to-date overview** can be obtained from the [Documentation](https://slds-lmu.github.io/yahpo_gym/scenarios.html).
The fidelity is given either as the dataset fraction `fraction` or the number of epochs `epoch`.
Search spaces can be numeric, mixed and have dependencies (as indicated in the `H` column).

Original data sources are given by:

- [1] Binder M., Pfisterer F. & Bischl B. (2020). Collecting Empirical Data About Hyperparameters for Data Driven AutoML. 7th ICML Workshop on Automated Machine Learning.
- [2] Siems, J., Zimmer, L., Zela, A., Lukasik, J., Keuper, M., & Hutter, F. (2020). NAS-Bench-301 and the Case for Surrogate Benchmarks for Neural Architecture Search. arXiv preprint arXiv:2008.09777, 11.
- [3] Zimmer, L. (2020). nasbench301_full_data. figshare. Dataset. https://doi.org/10.6084/m9.figshare.13286105.v1, Apache License, Version 2.0.
- [4] Zimmer, L., Lindauer, M., & Hutter, F. (2021). Auto-Pytorch: Multi-Fidelity Metalearning for Efficient and Robust AutoDL. IEEE Transactions on Pattern Analysis and Machine Intelligence, 43(9), 3079-3090.
- [5] Zimmer, L. (2020). data_2k_lw.zip. figshare. Dataset. https://doi.org/10.6084/m9.figshare.11662422.v1, Apache License, Version 2.0.
- [6] None, simply cite Pfisterer, F., Schneider, L., Moosbauer, J., Binder, M., & Bischl, B. (2022). YAHPO Gym - An Efficient Multi-Objective Multi-Fidelity Benchmark for Hyperparameter Optimization. In International Conference on Automated Machine Learning.

**Please make sure to always also cite the original data sources as YAHPO Gym would not have been possible without them!**

### Installation

```console
pip install yahpo-gym
```

### Setup

To run a benchmark you need to obatin the ONNX model (`new_model.onnx`), [ConfigSpace](https://automl.github.io/ConfigSpace/) (`config_space.json`) and some encoding info (`encoding.json`).

You can download these [here (Github)](https://github.com/slds-lmu/yahpo_data) or [here (Syncshare)](https://syncandshare.lrz.de/getlink/fiCMkzqj1bv1LfCUyvZKmLvd/).

You should pertain the folder structure as on the hosting site (i.e., create a `"path-to-data"` directory, for example named `"multifidelity_data"`, containing the individual, e.g., `"lcbench"`, directories).

```py
# Initialize the local config & set path for surrogates and metadata
from yahpo_gym import local_config
local_config.init_config()
local_config.set_data_path("path-to-data")
```
You can test whether the setup was successful by instantiating the object as documented in the **Usage** section below.

### Usage

This example showcases the simplicity of YAHPO Gym's API.
A longer introduction is given in the accompanying [jupyter notebook](https://github.com/slds-lmu/yahpo_gym/blob/main/yahpo_gym/notebooks/using_yahpo_gym.ipynb).

```py
from yahpo_gym import benchmark_set
import yahpo_gym.benchmarks.lcbench
# Select a Benchmark
bench = benchmark_set.BenchmarkSet("lcbench")
# List available instances
bench.instances
# Set an instance
bench.set_instance("3945")
# Sample a point from the configspace (containing parameters for the instance and budget)
config = bench.get_opt_space().sample_configuration(1).get_dictionary()
# Evaluate
print(bench.objective_function(config))
```

### A note on OpenML Task IDs

Currently, the `rbv2_*`, `lcbench`, and `iaml_*` scenarios contain instances based on OpenML datasets.
For `rbv2_*` and `iaml_*` scenarios, the `task_id` parameter of the `ConfigSpace` corresponds to the OpenML **dataset** identifier (i.e., this is the **dataset** id and **not** the task id).
To query meta information, use https://www.openml.org/d/<dataset_id>.
For the `lcbench` scenario, the `OpenML_task_id` parameter of the `ConfigSpace` directly corresponds to OpenML **tasks** identifier (i.e., this is the **task** id and **not** the dataset id).
To query meta information, use https://www.openml.org/t/<task_id>.

### Example: Tuning an instance using HPBandSter

We include a full example for optimization using **BOHB** on a YAHPO Gym instance in a [jupyter notebook](https://github.com/slds-lmu/yahpo_gym/blob/main/yahpo_gym/notebooks/tuning_hpandster_on_yahpo.ipynb).

### All Examples

- [General Usage](https://github.com/slds-lmu/yahpo_gym/blob/main/yahpo_gym/notebooks/using_yahpo_gym.ipynb)
- [Code Samples](https://github.com/slds-lmu/yahpo_gym/blob/main/yahpo_gym/notebooks/code_sample.ipynb)
- [Tuning with HpBandSter on YAHPO Gym](https://github.com/slds-lmu/yahpo_gym/blob/main/yahpo_gym/notebooks/tuning_hpandster_on_yahpo.ipynb)
- [Transfer HPO](https://github.com/slds-lmu/yahpo_gym/blob/main/yahpo_gym/notebooks/using_yahpo_gym.ipynb)
- [Paper Experiments](https://github.com/slds-lmu/yahpo_exps/tree/main/paper)

### Citation

If you use YAHPO Gym, please cite the following paper:

- Pfisterer, F., Schneider, L., Moosbauer, J., Binder, M., & Bischl, B. (2022). YAHPO Gym - An Efficient Multi-Objective Multi-Fidelity Benchmark for Hyperparameter Optimization. In International Conference on Automated Machine Learning.

Moreover, certain `scenarios` built upon previous work, e.g., the `lcbench` scenario uses data from:

- Zimmer, L., Lindauer, M., & Hutter, F. (2021). Auto-Pytorch: Multi-Fidelity Metalearning for Efficient and Robust AutoDL. IEEE Transactions on Pattern Analysis and Machine Intelligence, 43(9), 3079-3090.
- Zimmer, L. (2020). data_2k_lw.zip. figshare. Dataset. https://doi.org/10.6084/m9.figshare.11662422.v1, Apache License, Version 2.0.

**Please make sure to always also cite the original data sources as YAHPO Gym would not have been possible without them!**

Original data sources of a scenario that should also be cited are provided via the `"citation"` key within the `config` dictionary of a scenario, e.g.:

```py
from yahpo_gym.configuration import cfg
lcbench = cfg("lcbench")
lcbench.config.get("citation")
```

# Information about running HPOBench in a Container
Due to the setup of HPOBench, which uses containers itself, it does not run well within a container, so we do not offer
a recipe for it (old package versions are fixed if wanting to run HPOBench locally, which does not allow increasing the
python version etc. in the main carp-s environment/ container if this would be done. They cannot be increased easily
since old pickled surrogates need to be loaded in that environment in many cases). 

## Troubleshooting
If a container does not work,
- make sure singularity is available, especially if you are on a cluster (e.g. `ml system singularity`)
- it often helps to remove the container from the cache dir, e.g. `/home/username/.cache/hpobench/`.

# YAHPO Gym (R)
[![Unittests](https://github.com/slds-lmu/yahpo_gym/actions/workflows/unittests_gym_py.yml/badge.svg?branch=main)](https://github.com/slds-lmu/yahpo_gym/actions)
[![Module Handbook](https://img.shields.io/badge/Website-Documentation-blue)](https://slds-lmu.github.io/yahpo_gym/) 
[![Paper](https://img.shields.io/badge/arXiv-Paper-blue)](https://arxiv.org/abs/2109.03670)
[![Software (Python)](https://img.shields.io/badge/Software-Python-green)](https://github.com/slds-lmu/yahpo_gym/tree/main/yahpo_gym)

R Interface for the YAHPO Gym python module. Documentation for the python module is available via the [module handbook](https://slds-lmu.github.io/yahpo_gym/) while the R module builds its own documentation with the package.

### What is YAHPO Gym?

**YAHPO Gym** (Yet Another Hyperparameter Optimization Gym) is a collection of interesting problems to benchmark hyperparameter optimization (HPO) methods described in [our paper](https://arxiv.org/abs/2109.03670).
YAHPO Gym consists of several `scenarios`. A scenario (e.g. `lcbench`) is a collection of benchmark instances with the same underlying hyperparameter optimization task (e.g., optimizing the hyperparameters of a neural network) on different datasets (usually taken from [OpenML](https://www.openml.org/)).

**Overview over benchmark instances**

|Scenario    |Search Space    |# Instances|Target Metrics                       |Fidelity| H|     Source|
|:-----------|---------------:|----------:|------------------------------------:|:-------|-:|----------:|
|rbv2_super  |38D: Mixed      |        103| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|rbv2_svm    | 6D: Mixed      |        106| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|rbv2_rpart  | 5D: Mixed      |        117| 9: perf(6) + rt(2) + mem            |fraction|  |        [1]|
|rbv2_aknn   | 6D: Mixed      |        118| 9: perf(6) + rt(2) + mem            |fraction|  |        [1]|
|rbv2_glmnet | 3D: Mixed      |        115| 9: perf(6) + rt(2) + mem            |fraction|  |        [1]|
|rbv2_ranger | 8D: Mixed      |        119| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|rbv2_xgboost|14D: Mixed      |        119| 9: perf(6) + rt(2) + mem            |fraction| ✓|        [1]|
|nb301       |34D: Categorical|          1| 2: perf(1) + rt(1)                  |epoch   | ✓|   [2], [3]|
|lcbench     | 7D: Numeric    |         34| 6: perf(5) + rt(1)                  |epoch   |  |   [4], [5]|
|iaml_super  |28D: Mixed      |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction| ✓|        [6]|
|iaml_rpart  | 4D: Numeric    |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction|  |        [6]|
|iaml_glmnet | 2D: Numeric    |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction|  |        [6]|
|iaml_ranger | 8D: Mixed      |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction| ✓|        [6]|
|iaml_xgboost|13D: Mixed      |          4|12: perf(4) + inp(3) + rt(2) + mem(3)|fraction| ✓|        [6]|

The **full, up-to-date overview** can be obtained from the [Documentation](https://slds-lmu.github.io/yahpo_gym/scenarios.html).
The fidelity is given either as the dataset fraction `fraction` or the number of epochs `epoch`.
Search spaces can be numeric, mixed and have dependencies (as indicated in the `H` column).

Original data sources are given by:

- [1] Binder M., Pfisterer F. & Bischl B. (2020). Collecting Empirical Data About Hyperparameters for Data Driven AutoML. 7th ICML Workshop on Automated Machine Learning.
- [2] Siems, J., Zimmer, L., Zela, A., Lukasik, J., Keuper, M., & Hutter, F. (2020). NAS-Bench-301 and the Case for Surrogate Benchmarks for Neural Architecture Search. arXiv preprint arXiv:2008.09777, 11.
- [3] Zimmer, L. (2020). nasbench301_full_data. figshare. Dataset. https://doi.org/10.6084/m9.figshare.13286105.v1, Apache License, Version 2.0.
- [4] Zimmer, L., Lindauer, M., & Hutter, F. (2021). Auto-Pytorch: Multi-Fidelity Metalearning for Efficient and Robust AutoDL. IEEE Transactions on Pattern Analysis and Machine Intelligence, 43(9), 3079-3090.
- [5] Zimmer, L. (2020). data_2k_lw.zip. figshare. Dataset. https://doi.org/10.6084/m9.figshare.11662422.v1, Apache License, Version 2.0.
- [6] None, simply cite Pfisterer, F., Schneider, L., Moosbauer, J., Binder, M., & Bischl, B. (2022). YAHPO Gym - An Efficient Multi-Objective Multi-Fidelity Benchmark for Hyperparameter Optimization. In International Conference on Automated Machine Learning.

**Please make sure to always also cite the original data sources as YAHPO Gym would not have been possible without them!**

### Installation

The package can be installed from GitHub via

```r
remotes::install_github("slds-lmu/yahpo_gym/yahpo_gym_r")
```

### Setup

YAHPO Gym requires a one-time setup to install the required python dependencies.
Here we install all packages into the `yahpo_gym` conda environment.

```r
reticulate::conda_create(
  envname = "yahpo_gym",
  packages = c("onnxruntime", "pip", "pyyaml", "pandas"),
  channel = "conda-forge",
  python_version = "3.8"
)
reticulate::conda_install(envname = "yahpo_gym", packages="configspace", channel="conda-forge")
reticulate::conda_install(envname = "yahpo_gym", pip=TRUE,
  packages="'git+https://github.com/slds-lmu/yahpo_gym#egg=yahpo_gym&subdirectory=yahpo_gym'")
```

Now we can instantiate a local config that sets up the path files are installed to:

```r
reticulate::use_condaenv("yahpo_gym", required=TRUE)
library("yahpogym")
init_local_config(data_path = "~/multifidelity_data")
```
you can download the multifidelity data using 

```sh
git clone https://github.com/slds-lmu/yahpo_data.git
```

or from this URL: (https://github.com/slds-lmu/yahpo_data.git).

### Usage

We first load the package and the required conda environment:

```r
reticulate::use_condaenv("yahpo_gym", required=TRUE)
library("yahpogym")
```

and subsequently instantiate the benchmark (random search, full fidelity) to obtain our objective.

```r
b = BenchmarkSet$new("iaml_glmnet")
obj = b$get_objective("40981", multifidelity = FALSE)
```

and run our search procedure.

```r
library(bbotk)
p = opt("random_search")
ois = OptimInstanceBatchMultiCrit$new(obj, search_space = b$get_search_space(drop_fidelity_params = TRUE), terminator = trm("evals", n_evals = 10))
p$optimize(ois)
```

Note that specifying `multifidelity = FALSE` in the `$get_objective()` method of a `BenchmarkSet` always also requires
to specify `drop_fidelity_params = TRUE` when getting the search space via `$get_search_space()`.

#### or with Hyperband using (`mlr3hyperband`)

```r
library(mlr3hyperband)
obj = b$get_objective("40981", multifidelity = TRUE)
ois = OptimInstanceBatchMultiCrit$new(obj, search_space = b$get_search_space(), terminator = trm("none"))
p = opt("hyperband")
p$optimize(ois)
```

We can list all available benchmark problems:

```r
str(list_benchmarks())
```

and available instances in a `Benchmark`:

```r
b$instances
```

### A note on OpenML IDs

Currently, the `rbv2_*`, `lcbench`, and `iaml_*` scenarios contain instances based on OpenML datasets.
For `rbv2_*` and `iaml_*` scenarios, the `task_id` parameter of the `ConfigSpace` corresponds to the OpenML **dataset** identifier (i.e., this is the **dataset** id and **not** the task id).
To query meta information, use https://www.openml.org/d/<dataset_id>.
For the `lcbench` scenario, the `OpenML_task_id` parameter of the `ConfigSpace` directly corresponds to OpenML **tasks** identifier (i.e., this is the **task** id and **not** the dataset id).
To query meta information, use https://www.openml.org/t/<task_id>.

### Technical Questions:

#### Single-Crit Optimization

We can use `subset_codomain` to obtain a single-crit optimization instance by specifying the target to keep:

```r
b$subset_codomain("auc")
obj = b$get_objective("40981", multifidelity = FALSE)
```

#### Using yahpogym with `future`

Parallelization with `future` and `reticulate` does not always work out of the box.
The following configurations allow to use `yahpogym` together with `future`.

1. If `yahpogym` requires a conda env / virtual env set up the `.Renvirion` file by adding 
  `RETICULATE_PYTHON=path_to_conda_python_bin`. This path can be obtained through `reticulate::py_discover_config()`.

2. Silence `future` warnings using `options(future.globals.onReference = "string")`.
  Note: `future`s check will still find unresolved references, but `yahpogym` constructs those on the child process via active bindings.

3. Run the evaluation using `future`:
  ```r
    b = BenchmarkSet$new("lcbench")
    objective = b$get_objective("3945", check_values = FALSE)

    xdt = generate_design_random(b$get_search_space(), 1)$data
    xss_trafoed = transform_xdt_to_xss(xdt, b$get_search_space())

    future::plan("multisession")
    promise = future::future(objective$eval_many(xss_trafoed), packages = "yahpogym", seed = NULL)
    future::value(promise)
  ```

#### Radian

Since `yahpogym` relies on `reticulate`, interoperability with e.g. `radian` does sometimes not work. 
See [here](https://github.com/randy3k/radian#i-cant-specify-python-runtime-in-reticulate) for more information.

### Citation

If you use YAHPO Gym, please cite the following paper:

- Pfisterer, F., Schneider, L., Moosbauer, J., Binder, M., & Bischl, B. (2022). YAHPO Gym - An Efficient Multi-Objective Multi-Fidelity Benchmark for Hyperparameter Optimization. In International Conference on Automated Machine Learning.

Moreover, certain `scenarios` built upon previous work, e.g., the `lcbench` scenario uses data from:

- Zimmer, L., Lindauer, M., & Hutter, F. (2021). Auto-Pytorch: Multi-Fidelity Metalearning for Efficient and Robust AutoDL. IEEE Transactions on Pattern Analysis and Machine Intelligence, 43(9), 3079-3090.
- Zimmer, L. (2020). data_2k_lw.zip. figshare. Dataset. https://doi.org/10.6084/m9.figshare.11662422.v1, Apache License, Version 2.0.

**Please make sure to always also cite the original data sources as YAHPO Gym would not have been possible without them!**

Original data sources of a scenario that should also be cited are provided via the `"citation"` key within the `config` dictionary of a scenario, which can be accessed from a `BenchmarkSet` via the following:

```r
reticulate::use_condaenv("yahpo_gym", required=TRUE)
library("yahpogym")
b = BenchmarkSet$new("lcbench")
b$py_instance$config$config$citation
```

# YAHPO Gym - Train
[![Module Handbook](https://img.shields.io/badge/Website-Documentation-blue)](https://slds-lmu.github.io/yahpo_gym/) 
[![Paper](https://img.shields.io/badge/arXiv-Paper-blue)](https://arxiv.org/abs/2109.03670)
[![Software (Python)](https://img.shields.io/badge/Software-Python-green)](https://github.com/slds-lmu/yahpo_gym/tree/main/yahpo_gym)
[![Software (R)](https://img.shields.io/badge/Software-R-green)](https://github.com/slds-lmu/yahpo_gym/tree/main/yahpo_gym_r)

Train and evaluate surrogates for HPO problems.

Code for tuning and training the surrogates can be found in the `notebooks` folder https://github.com/slds-lmu/yahpo_gym/blob/main/yahpo_train/notebooks/tune_resnet.py

Each function evalution returns a dictionary with the following information:

```
└───function_value: 1 - accuracy (acc.) on validation set
└───cost: time to fit model + time to evaluate acc. training set + time to evaluate acc. validation set
└───info: dictionary (dict) with miscellaneous information
|   └───train_loss: 1 - accuracy (acc.) on training set
|   └───val_loss: 1 - accuracy (acc.) on validation set
|   └───model_cost: time taken to fit the model
|   └───train_scores: performance on all metrics over the training set (dict)
|   |   └───f1: F1-score   
|   |   └───acc: Accuracy
|   |   └───bal_acc: Balanced accuracy
|   └───train_costs: time taken to compute performance on all metrics over the training set (dict)
|   |   └───f1: F1-score   
|   |   └───acc: Accuracy
|   |   └───bal_acc: Balanced accuracy 
|   └───valid_scores: performance on all metrics over the validation set (dict)
|   |   └───...
|   └───valid_costs: time taken to compute performance on all metrics over the validation set (dict)
|   |   └───...
|   └───test_scores: performance on all metrics over the test set
|   |   └───...
|   └───test_costs: time taken to compute performance on all metrics over the test set (dict)
|   |   └───...
```

*NOTE*: the keys `function_value`, `cost`, `info` need to exist when creating a new objective 
function, while `info` can house any kind of auxilliary information required.

#' @title Initialize a local configuration
#'
#' @details
#'  Allows setting a path the required meta-data for YAHPO Gym is installed to.
#' @param data_path `character`\cr
#'  Path to save meta-data to.
#' @param settings_path `character`\cr
#'  Path to save configuration object including "path" to.
#' @export
init_local_config = function(data_path = NULL, settings_path = "~/.config/yahpo_gym") {
  assert_string(data_path, null.ok = TRUE)
  assert_string(settings_path, null.ok = TRUE)
  lc = reticulate::import("yahpo_gym.local_config")$LocalConfiguration(settings_path)
  lc$init_config(data_path = data_path)
  if (!is.null(data_path)) {
      lc$set_data_path(data_path)
  }
}

#' @title Print available benchmarks
#' @return A [`Configuration`] (Python Object)
#' @export
list_benchmarks = function() {
  yp = reticulate::import("yahpo_gym.configuration")
  yp$cfg()
}

is0x0ptr = function(pointer) {
  out = utils::capture.output(pointer)
  return(out == "<pointer: 0x0>")
}

test_that("listing works", {
  skip_on_ci()
  reticulate::use_condaenv("yahpo_gym", required = TRUE)
  a = list_benchmarks()
  expect_class(a, "yahpo_gym.configuration.ConfigDict")
})

test_that("local config", {
  skip_on_ci()
  reticulate::use_condaenv("yahpo_gym", required = TRUE)
  tmp = tempfile()
  init_local_config("foo/bar", tmp)
  t = readLines(tmp)
  expect_true(t[1] == "data_path: foo/bar")
  unlink(tmp)
})

test_that("preproc_xs", {
  skip_on_ci()
  l = list(list(a = 1, b = NA))
  expect_identical(preproc_xs(l), list(list(a = 1)))
  expect_identical(preproc_xs(l, c = 3), list(list(a = 1, c = 3)))
  expect_identical(preproc_xs(l, c = 3, d = NA), list(list(a = 1, c = 3)))
})

ObjectiveYAHPO = R6::R6Class("ObjectiveYAHPO",
  inherit = bbotk::Objective,
  public = list(
    timed = NULL,
    logging = NULL,
    multithread = NULL,
    seed = NULL,
    check_codomain = NULL,

    initialize = function(instance, multifidelity = TRUE, py_instance_args, domain, codomain = NULL, check_values = TRUE, timed = FALSE, logging = FALSE, multithread = FALSE, seed = 0L, check_codomain = FALSE) {
      assert_flag(multifidelity)
      assert_flag(check_values)
      self$timed = assert_flag(timed)
      self$logging = assert_flag(logging)
      self$multithread = assert_flag(multithread)
      self$seed = assert_int(seed, null.ok = TRUE)
      self$check_codomain = assert_flag(check_codomain)

      if (is.null(codomain)) {
        codomain = ps(y = p_dbl(tags = "minimize"))
      }
      private$.py_instance_args = assert_list(py_instance_args, names = "named")

      # set constant instance / fidelities and define domain over all other values
      instance_param = self$py_instance$config$instance_names
      fidelity_params = if (!multifidelity) self$py_instance$config$fidelity_params else NULL
      pars = setdiff(domain$ids(), c(instance_param, fidelity_params))
      domain_new = domain$subset(pars)  # this also handles trafo and dependencies

      # define constants param_set
      cst = ps()
      if (length(instance_param)) {
        cst = ps_union(list(cst,
          domain$subset(instance_param)
        ))
        cst$set_values(.values = structure(list(instance), names = instance_param))
      }
      if (length(fidelity_params)) {
        cst = ps_union(list(cst,
          domain$subset(fidelity_params)
        ))
        cst$set_values(.values = structure(as.list(domain$upper[fidelity_params]), names = fidelity_params))
      }

      noise = ifelse(py_instance_args$noisy, "noisy", "deterministic")
      # asserts id, domain, codomain, properties
      super$initialize(
        id = paste0("YAHPO_", py_instance_args$scenario),
        domain = domain_new,
        codomain = codomain,
        properties = noise,
        constants = cst,
        check_values = assert_flag(check_values)
      )
    },
    eval = function(xs) {
      if (self$check_values) self$domain$assert(xs)
      if (is.null(private$.fun)) {
        private$.set_fun()
      }
      res = invoke(private$.fun, list(xs), .args = self$constants$values)
      res = res[[1]][self$codomain$ids()]
      if (self$check_codomain) self$codomain$assert(as.list(res)[self$codomain$ids()])
      return(res)
    },
    export = function() {
      private$.export()
    }
  ),

  private = list(
    .fun = NULL,
    .py_instance = NULL,
    .py_instance_args = NULL,
    .export = function() {
      private$.py_instance = NULL
      private$.fun = NULL
      private$.py_instance_args$onnx_session = NULL
      private$.py_instance_args$active_session = FALSE
    },
    .set_fun = function() {
      if (self$timed) {
        private$.fun = function(xs, ...) {
          self$py_instance$objective_function_timed(
            preproc_xs(xs, ...), seed = self$seed,
            logging = self$logging, multithread = self$multithread
          )
        }
      } else {
        private$.fun = function(xs, ...) {
          self$py_instance$objective_function(
            preproc_xs(xs, ...), seed = self$seed,
            logging = self$logging, multithread = self$multithread
          )
        }
      }
    },
    .eval_many = function(xs, ...) {
      if (is.null(private$.fun)) {
        private$.set_fun()
      }
      res = invoke(private$.fun, xs = xs, .args = self$constants$values)
      data.table::rbindlist(res)[, self$codomain$ids(), with = FALSE]
    }
  ),


  active = list(
    #' @field py_instance (`yahpogym.BenchmarkInstance`)\cr
    #' Python object.
    py_instance = function() {
      if (is.null(private$.py_instance) | is0x0ptr(private$.py_instance)) {
        gym = reticulate::import("yahpo_gym")
        args = private$.py_instance_args
        private$.py_instance = gym$benchmark_set$BenchmarkSet(
          args$scenario, session=args$onnx_session, active_session = args$active_session,
          check = args$check, noisy = args$noisy, multithread = args$multithread
        )
      }
      return(private$.py_instance)
    },
    #' @field fun (`function`)\cr
    #' Objective function.
    fun = function(lhs) {
      if (!missing(lhs) && !identical(lhs, private$.fun)) stop("fun is read-only")
      private$.fun
    }
  )
)

#' @title Preprocess r object for use with python's YAHPO Gym
#' @param xss `list` of `list` \cr
#'   List of hyperparams
#' @param ... `any` \cr
#'   Named params, appended to `xss`.
#' @export
preproc_xs = function(xss, ...) {
  csts = list(...)
  map(xss, function(xs) {
    xs = map(as.list(xs), function(x) {
      if (is.logical(x)) {
        as.character(x)  # NOTE: logical parameters are represented as categoricals in ConfigSpace and we fix this here
      } else {
        x
      }
    })
    keep(c(xs, csts), Negate(is.na))
  })
}

#' @import checkmate
#' @import mlr3misc
#' @import paradox
#' @import bbotk
#' @import R6
#' @import data.table
#' @importFrom stats setNames
#' @description
#' A package that connects YAHPO Gym to R.
"_PACKAGE"

.onLoad = function(libname, pkgname) { # nocov start
    reticulate::configure_environment(pkgname)
} # nocov end

# static code checks should not complain about commonly used data.table columns
utils::globalVariables(c("search_space", "domain", "codomain", "quant"))

leanify_package()

# Installation instructions: https://github.com/slds-lmu/yahpo_gym/tree/main/yahpo_gym_r
reticulate::use_condaenv("yahpo_gym", required=TRUE)
setwd("yahpo_gym_r")
devtools::load_all()

# Instiate the benchmark
bs = BenchmarkSet$new("nb301")

# Available targets
bs$codomain
# Available hyperparameters
bs$domain

bs$subset_codomain("val_accuracy")


# Available: bs$instances
obj = bs$get_objective("CIFAR10")


library("bbotk")
# Run 100 random evaluations
ins = bb_optimize(obj, max_evals = 100)
# Obtain results
df = ins$instance$archive$data[, c(names(bs$domain$params), names(bs$codomain$params)), with = FALSE] 
str(df, 1)

# Compute gower distance
library("gower")
gower_dist(df[1,], df[2,])

##' Benchmark Set
#'
#' R interface to a YAHPO Gym BenchmarkSet.
#'
#' @details
#' Allows exporting the objective function from a `YAHPO Gym` BenchmarkSet.
#' and additional helper functionality.
#'
#' @section Methods:
#'   * new(key, onnx_session, active_session): Initialize the class.
#'   * get_objective(): Obtain the [`bbotk::Objective`].
#'   * get_opt_space_py(): Obtain the [`ConfigSpace`].
#'
#' @section Fields:
#'   * session: [`onnx.InferenceSession`] \cr
#'   * instances: [`character`] \cr
#'
#' @examples
#' \dontrun{
#' b = BenchmarkSet$new("lcbench")
#' b$instances
#' }
#' @export
BenchmarkSet = R6::R6Class("BenchmarkSet",
  public = list(

    #' @field id `character` \cr
    #'   The scenario identifier.
    id = NULL,

    #' @field instance `character` \cr
    #'   The instance identifier.
    instance = NULL,

    #' @field onnx_session `onnxruntime.InferenceSession` \cr
    #'   A session to use for the predict. If `NULL` a new session is initialized.
    onnx_session = NULL,

    #' @field active_session `logical` \cr
    #'   Should the benchmark run in an active `onnxruntime.InferenceSession`? Initialized to `FALSE`.
    active_session = NULL,

    #' @field multithread `logical` \cr
    #'   Should the ONNX session be allowed to leverage multithreading capabilities?
    multithread = NULL,

    #' @field check `logical` \cr
    #'   Check whether values coincide with `domain`.
    check = NULL,

    #' @field check_codomain `logical` \cr
    #'   Check whether returned values coincide with `codomain`.
    check_codomain = NULL,

    #' @field noisy `logical` \cr
    #'   Whether noisy surrogates should be used.
    noisy = NULL,

    #' @description
    #' Initialize a new object
    #'
    #' @param scenario `character` \cr
    #'   Key for a benchmark scenario. See [`list_benchmarks`] for more information.
    #' @param instance [`character`] \cr
    #'   A valid instance. See `instances`.
    #' @param onnx_session `onnxruntime.InferenceSession` \cr
    #'   A matching `onnxruntime.InferenceSession`. See `session` for more information.
    #'   If no session is provided, new session is created.
    #' @param active_session `logical` \cr
    #'   Should the benchmark run in an active `onnxruntime.InferenceSession`? Initialized to `FALSE`.
    #' @param multithread `logical` \cr
    #'   Should the ONNX session be allowed to leverage multithreading capabilities? Default `FALSE`.
    #' @param check `logical` \cr
    #'   Check inputs for validity before passing to surrogate model? Default `FALSE`.
    #' @param noisy `logical` \cr
    #'   Should noisy surrogates be used instead of deterministic ones?
    #' @param check_codomain `logical` \cr
    #'   Check outputs of surrogate model for validity? Default `FALSE`.
    initialize = function(scenario, instance = NULL, onnx_session = NULL, active_session = FALSE, multithread = FALSE, check = FALSE, noisy = FALSE, check_codomain = FALSE) {
      self$id = assert_string(scenario)
      self$instance = assert_string(instance, null.ok = TRUE)
      self$onnx_session = onnx_session
      self$active_session = assert_flag(active_session)
      self$multithread = assert_flag(multithread)
      self$check = assert_flag(check)
      self$noisy = assert_flag(noisy)
      self$check_codomain = assert_flag(check_codomain)
    },
    #' @description
    #' Printer with some additional information.
    print = function() {
      cat(format(self))
      cat("\n\n Targets: (Codomain)\n")
      print(self$codomain)
      cat("\nHyperparameters: (Domain)\n")
      print(self$domain)
      cat("\nAvailable instances:\n")
      print(self$instances)
    },

    #' @description
    #' Get the objective function
    #'
    #' @param instance [`character`] \cr
    #'   A valid instance. See `instances`.
    #' @param multifidelity (`logical`) \cr
    #'   Should the objective function respect multifidelity?
    #'   If `FALSE`, fidelity parameters are set as constants with their max fidelity in the domain.
    #' @param check_values (`logical`) \cr
    #'   Should values be checked by bbotk? Initialized to `TRUE`.
    #' @param timed (`logical`) \cr
    #'   Should function evaluation simulate runtime? Initialized to `FALSE`.
    #' @param logging (`logical`) \cr
    #'   Should function evaluation be logged? Initialized to `FALSE`.
    #' @param multithread `logical` \cr
    #'   Should the ONNX session be allowed to leverage multithreading capabilities? Default `FALSE`.
    #' @param seed `integer` \cr
    #'   Initial seed for the `onnxruntime.runtime`. Only relevant if `noisy = TRUE`. Default `NULL` (no seed).
    #' @param check_codomain `logical` \cr
    #'   Check outputs of surrogate model for validity? Default `FALSE`.
    #' @return
    #'  A [`Objective`][bbotk::Objective] containing "domain", "codomain" and a
    #'  functionality to evaluate the surrogates.
    get_objective = function(instance, multifidelity = TRUE, check_values = TRUE, timed = FALSE, logging = FALSE, multithread = FALSE, seed = NULL, check_codomain = FALSE) {
      assert_choice(instance, self$instances)
      assert_flag(check_values)
      assert_int(seed, null.ok = TRUE)
      assert_flag(check_codomain)
      ObjectiveYAHPO$new(
        instance,
        multifidelity,
        list(
          scenario = self$id,
          session = self$onnx_session,
          active_session = self$active_session,
          check = self$check,
          multithread = self$multithread,
          noisy = self$noisy
        ),
        self$domain,
        self$codomain,
        check_values = check_values,
        timed = timed,
        logging = logging,
        multithread = multithread,
        seed = seed,
        check_codomain = check_codomain
      )
    },
    #' @description
    #' Get Optimization Search Space
    #'
    #' A [`paradox::ParamSet`] describing the search_space used during optimization.
    #' Typically, this is the same as the domain but, e.g., with some parameters on log scale.
    #' This is the same space as the one returned by `get_opt_space_py` (with the instance param dropped).
    #' Typically this search_space should be provided when creating an [bbotk::OptimInstance].
    #' @param drop_instance_param [`logical`] \cr
    #'   Should the instance param (e.g., task id) be dropped? Defaults to `TRUE`.
    #' @param drop_fidelity_params [`logical`] \cr
    #'   Should fidelity params be dropped? Defaults to `FALSE`.
    #' @return
    #'  A [`paradox::ParamSet`] containing the search space to optimize over.
    get_search_space = function(drop_instance_param = TRUE, drop_fidelity_params = FALSE) {
      search_space = private$.load_r_domains()$search_space
      params = search_space$ids()
      if (drop_instance_param) {
        params = setdiff(params, self$py_instance$config$instance_names)
      }
      if (drop_fidelity_params) {
        params = setdiff(params, self$py_instance$config$fidelity_params)
      }
      search_space_new = search_space$subset(params)  # subset() handles trafo & dependencies

      search_space_new
    },

    #' @description
    #' Get Optimization ConfigSpace
    #'
    #' @param drop_fidelity_params [`logical`] \cr
    #'   Should fidelity params be dropped? Defaults to `TRUE`.
    #' @return
    #'  A configspace containing the search space to optimize over.
    get_opt_space_py = function(drop_fidelity_params = TRUE) {
      self$py_instance$get_opt_space(drop_fidelity_params)
    },

    #' @description
    #' Subset the codomain. Sets a new domain.
    #'
    #' @param keep (`character`) \cr
    #'   Vector of co-domain target names to keep.
    #' @return
    #'  A [`paradox::ParamSet`] containing the output space (codomain).
    subset_codomain = function(keep) {
      codomain = self$codomain
      assert_subset(keep, codomain$ids())
      new_codomain = codomain$subset(keep)
      private$.domains$codomain = new_codomain
    }
  ),

  active = list(

    #' @field session `onnxruntime.InferenceSession` \cr
    #' Set/Get the ONNX session.
    #'
    #' The param `sess` is a `onnxruntime.InferenceSession`\cr
    #'   A matching `onnxruntime.InferenceSession`. Please make sure
    #'   that the session matches the selected benchmark scenario, as no
    #'   additional checks are performed and inference will fail during
    #'   evaluation of the objective function.
    session = function(sess) {
      if (missing(sess)) {
        return(self$py_instance$session)
      } else {
        self$py_instance$set_session(sess)
      }
    },

    #' @field instances `character` \cr
    #' A character vector of available instances for the scenario.
    instances = function() {
      self$py_instance$instances
    },

    #' @field domain `ParamSet` \cr
    #' A [`paradox::ParamSet`] describing the domain to be optimized over.
    domain = function() {
      private$.load_r_domains()$domain
    },

    #' @field codomain `ParamSet` \cr
    #' A [`paradox::ParamSet`] describing the output domain.
    codomain = function() {
      private$.load_r_domains()$codomain
    },
    #' @field quant `numeric` \cr
    #' Multiply runtime by this factor. Defaults to 0.01.
    quant = function(val) {
      if (missing(val)) {
        return(quant)
      }
      assert_number(quant)
      self$py_instance$quant = val
    },

    #' @field py_instance [`BenchmarkSet`] \cr
    #'   A python `yahpo_gym.BenchmarkSet`.
    py_instance = function() {
      if (is.null(private$.py_instance)) {
        gym = reticulate::import("yahpo_gym")
        tmp = reticulate::py_capture_output({
          private$.py_instance = gym$benchmark_set$BenchmarkSet(
            scenario = self$id, instance = self$instance, session = self$onnx_session, active_session = self$active_session,
            multithread = self$multithread, noisy = self$noisy
          )
        })
      }
      return(private$.py_instance)
    }
  ),

  private = list(
    .py_instance = NULL,

    .domains = NULL,

    .load_r_domains = function(instance) {
      if (is.null(private$.domains)) {
        ps_path = self$py_instance$config$get_path("param_set")
        source(ps_path, local = environment())
        private$.domains = list(search_space = search_space, domain = domain, codomain = codomain)
      }
      private$.domains
    }
  )
)

test_that("BenchmarkSet can be instantiated", {
  skip_on_ci()
  reticulate::use_condaenv("yahpo_gym", required = TRUE)
  b = BenchmarkSet$new("lcbench", instance = "3945", active_session = TRUE)
  id = reticulate::py_id(b$session)
  expect_r6(b, "BenchmarkSet")
  expect_character(b$instances, len = 34L)
  expect_class(b$py_instance, "yahpo_gym.benchmark_set.BenchmarkSet")
  expect_class(b$session, "onnxruntime.capi.onnxruntime_inference_collection.InferenceSession")
  expect_true(b$id == "lcbench")
  expect_class(b$get_opt_space_py(FALSE), "ConfigSpace.configuration_space.ConfigurationSpace")
  # Can build the objective
  obj = b$get_objective("189909")
  expect_r6(obj, "ObjectiveYAHPO")
  expect_r6(obj$domain, "ParamSet")
  expect_r6(obj$codomain, "ParamSet")
  # Can be optimized
  p = opt("random_search")
  ois = OptimInstanceBatchMultiCrit$new(obj, terminator = trm("evals", n_evals = 10L), check_values = FALSE)
  p$optimize(ois)
  expect_true(nrow(ois$archive$data) == 10L)
  # We stay in the same session
  expect_true(id == reticulate::py_id(b$session))
  # Errors
  expect_error(b$get_objective("123"))

  b2 = BenchmarkSet$new("lcbench", instance = "3945",onnx_session = b$session)
  expect_true(id == reticulate::py_id(b2$session))
  expect_r6(b2, "BenchmarkSet")
  expect_character(b2$instances, len = 34L)
  expect_class(b2$py_instance, "yahpo_gym.benchmark_set.BenchmarkSet")
  expect_class(b2$session, "onnxruntime.capi.onnxruntime_inference_collection.InferenceSession")
  expect_true(b2$id == "lcbench")
  expect_class(b2$get_opt_space_py(FALSE), "ConfigSpace.configuration_space.ConfigurationSpace")
  # Can build the objective
  obj2 = b2$get_objective("189909")
  expect_r6(obj2, "ObjectiveYAHPO")
  expect_r6(obj2$domain, "ParamSet")
  expect_r6(obj2$codomain, "ParamSet")
  # Can be optimized
  p = opt("random_search")
  ois2 = OptimInstanceBatchMultiCrit$new(obj2, terminator = trm("evals", n_evals = 10L), check_values = FALSE)
  p$optimize(ois2)
  expect_true(nrow(ois2$archive$data) == 10L)
  expect_true(id == reticulate::py_id(b2$session))
})

test_that("Subsetting works", {
  skip_on_ci()
  reticulate::use_condaenv("yahpo_gym", required = TRUE)
  b = BenchmarkSet$new("lcbench", active_session = TRUE)
  b$subset_codomain("val_accuracy")
  expect_true(b$codomain$ids() == "val_accuracy")
})

test_that("Parallel", {
  skip_on_ci()
  withr::with_envvar(
    new = c(RETICULATE_PYTHON = Sys.getenv("RETICULATE_PYTHON_YAHPO")),
    {
      options(future.globals.onReference = "string")
      reticulate::use_condaenv("yahpo_gym", required = TRUE)
      b = BenchmarkSet$new("lcbench")
      objective = b$get_objective("3945", timed = FALSE, check_values = FALSE)

      xdt = generate_design_random(b$get_search_space(), n = 1L)$data
      xss_trafoed = transform_xdt_to_xss(xdt, b$get_search_space())
      expect_true(nrow(objective$eval_many(xss_trafoed)) == 1L)

      future::plan("multisession")
      pss = replicate(2L, {
        xdt = generate_design_random(b$get_search_space(), n = 1L)$data
        xss_trafoed = transform_xdt_to_xss(xdt, b$get_search_space())
        promise = future::future(objective$eval_many(xss_trafoed), packages = "yahpogym", seed = NULL, lazy = TRUE)
      })
      expect_true(length(map(pss, future::value)) == 2L)

      promise = future::future(objective$eval_many(xss_trafoed), packages = "yahpogym", seed = NULL)
      expect_true(nrow(future::value(promise)) == 1L)
    })
})

test_that("Objective eval and eval_many", {
  skip_on_ci()
  reticulate::use_condaenv("yahpo_gym", required = TRUE)
  b = BenchmarkSet$new("lcbench", active_session = TRUE)
  obj = b$get_objective("34539")
  des = paradox::generate_design_random(obj$domain, n = 10L)
  res1 = obj$eval_dt(des$data)
  expect_data_table(res1)
  ll = transpose_list(des$data)
  res2 = data.table::rbindlist(map(ll, obj$eval))
  expect_data_table(res2)
  expect_equal(colnames(res1), colnames(res2))
})

#' Get versioned task sets
#' @description
#' Get Optimization ConfigSpace
#'
#' @param type [`character`] \cr
#'   Type of task set to get. For now 'single' (single-crit) and 'multi' (multi-crit) are supported.
#' @param version [`numeric`] \cr
#'   Version of the task set to get. Default is `1.0`.
#' @return
#'  A data.frame containing a list of tasks.
get_suites = function(type, version = 1.0) {
    version = assert_numeric(version)
    gym = reticulate::import("yahpo_gym")
    gym$get_tasks$get_tasks(type, version)
}

library("yahpogym")
library("paradox")
library("bbotk")
# Instantiate the BenchmarkSet
b = BenchmarkSet$new('lcbench', instance='3945')
# Get the objective
objective = b$get_objective('3945', check_values = FALSE)
# Sample a point from the ConfigSpace
xdt = generate_design_random(b$get_search_space(), 1)$data
xss_trafoed = transform_xdt_to_xss(xdt, b$get_search_space())
# Evaluate the configuration
objective$eval_many(xss_trafoed)

#!/bin/bash
# If you want to use yahpo locally and do not want to change to an old ConfigSpace version
# run this :)
# Run from root of repo
CONDA_ENV_NAME=$1
PIP=$PIP
CARPS_ROOT=$(python -c "from carps.utils.env_vars import CARPS_ROOT; print(CARPS_ROOT)")

if [ -z "$PIP" ]
then
    PIP="pip"
fi

if [ -z "$CONDA_ENV_NAME" ]
then
    CONDA_RUN_COMMAND=
else
    CONDA_RUN_COMMAND="${CONDA_COMMAND} run ${CONDA_ENV_NAME}"
fi

# Install yahpo-gym
git clone https://github.com/automl/yahpo_gym.git lib/yahpo_gym
$CONDA_RUN_COMMAND $PIP install lib/yahpo_gym/yahpo_gym

# Get task data
YAHPO_TASK_DATA_DIR=$(python -c "from carps.objective_functions.yahpo import YAHPO_TASK_DATA_DIR; print(YAHPO_TASK_DATA_DIR)")
echo "YAHPO_TASK_DATA_DIR: $YAHPO_TASK_DATA_DIR"
mkdir -p $YAHPO_TASK_DATA_DIR
git clone https://github.com/slds-lmu/yahpo_data.git $YAHPO_TASK_DATA_DIR
$CONDA_RUN_COMMAND python $CARPS_ROOT/container/recipes/benchmarks/YAHPO/patch_yahpo_configspace.py
$CONDA_RUN_COMMAND $PIP install ConfigSpace --upgrade

#!/usr/bin/env sh

if [[ "$RUN_TESTS" == "true" ]]; then
    if [[ "$RUN_CODECOV" == "true" ]]; then
        echo "Run tests with code coverage"
        pytest -sv --cov=hpobench tests/
        exit_code=$?

        echo "Run code coverage"
        codecov
    else
        echo "Run tests without code coverage"
        pytest -sv tests/
        exit_code=$?
    fi

    if [[ "$exit_code" -eq 0 ]]; then
        echo "All test have passed."
    else
        echo "Some Tests have failed."
        exit 1
    fi
fi

if [[ "$RUN_CODESTYLE" == "true" ]]; then
    echo "Run codestyle"
    chmod +x ci_scripts/codestyle.sh && source ./ci_scripts/codestyle.sh
fi

if [[ "$RUN_CONTAINER_EXAMPLES" == "true" ]]; then
    echo "Run containerized examples"
    chmod +x ci_scripts/container_examples.sh && source ./ci_scripts/container_examples.sh
fi

if [[ "$RUN_LOCAL_EXAMPLES" == "true" ]]; then
    echo "Run containerized examples"
    chmod +x ci_scripts/local_examples.sh && source ./ci_scripts/local_examples.sh
fi

#!/usr/bin/env sh

install_packages=""

if [[ "$RUN_TESTS" == "true" ]]; then
    echo "Install tools for testing"
    install_packages="${install_packages}xgboost,pytest,test_paramnet,test_tabular_datamanager,"
    pip install codecov

    # The param net benchmark does not work with a scikit-learn version != 0.23.2. (See notes in the benchmark)
    # To make sure that no newer version is installed, we install it before the other requirements.
    # Since we are not using a "--upgrade" option later on, pip skips to install another scikit-learn version.
    echo "Install the right scikit-learn function for the param net tests."
    pip install --upgrade scikit-learn==0.23.2
else
    echo "Skip installing tools for testing"
fi

if [[ "$RUN_CODESTYLE" == "true" ]]; then
    echo "Install tools for codestyle checking"
    install_packages="${install_packages}codestyle,"
else
    echo "Skip installing tools for codestyle checking"
fi

if [[ "$RUN_CONTAINER_EXAMPLES" == "true" ]]; then
    echo "Install packages for container examples"
    echo "Install swig"
    sudo apt-get update && sudo apt-get install -y build-essential swig
else
    echo "Skip installing packages for container examples"
fi

if [[ "$RUN_LOCAL_EXAMPLES" == "true" ]]; then
    echo "Install packages for local examples"
    echo "Install swig"
    sudo apt-get update && sudo apt-get install -y build-essential swig
    install_packages="${install_packages}xgboost,"
else
    echo "Skip installing packages for local examples"
fi

if [[ "$USE_SINGULARITY" == "true" ]]; then
    echo "Install Singularity"

    sudo apt-get update && sudo apt-get install -y \
      build-essential \
      libssl-dev \
      uuid-dev \
      libgpgme11-dev \
      squashfs-tools \
      libseccomp-dev \
      wget \
      pkg-config \
      git \
      cryptsetup

    export VERSION=3.5.3 && # adjust this as necessary \
      wget https://github.com/sylabs/singularity/archive/refs/tags/v${VERSION}.tar.gz && \
      tar -xzf v${VERSION}.tar.gz && \
      cd singularity-${VERSION}

    ./mconfig && \
      make -C builddir && \
      sudo make -C builddir install

    cd ..
    install_packages="${install_packages}placeholder,"
else
    echo "Skip installing Singularity"
fi

# remove the trailing comma
install_packages="$(echo ${install_packages} | sed 's/,*\r*$//')"
echo "Install HPOBench with options: ${install_packages}"
pip install .["${install_packages}"]

if ! command -v unzip &> /dev/null; then
    echo "unzip could not be found, installing it now. If it errors, might need to run as root. (sudo apt ...)"
    apt update && apt install unzip -y
fi

HPOB_TASK_DATA_DIR=$(python -c "from carps.objective_functions.hpo_b import HPOB_TASK_DATA_DIR; print(HPOB_TASK_DATA_DIR)")
HPOB_SURROGATES_DIR=$(python -c "from carps.objective_functions.hpo_b import HPOB_SURROGATES_DIR; print(HPOB_SURROGATES_DIR)")

if [ -z "$(ls -A $HPOB_SURROGATES_DIR)" ]; then
    echo "Directory is empty, proceeding with download."
else
    echo "Directory is not empty, skipping download."
    exit 0
fi
wget https://rewind.tf.uni-freiburg.de/index.php/s/rTwPgaxS2Z7NH39/download/saved-surrogates.zip -P $HPOB_SURROGATES_DIR
unzip $HPOB_SURROGATES_DIR/saved-surrogates.zip -d $HPOB_TASK_DATA_DIR
rm $HPOB_SURROGATES_DIR/saved-surrogates.zip

#!/usr/bin/env sh

if [[ "$RUN_CODESTYLE" == "true" ]]; then
    echo "Performing codestyle checking"

    test_codestyle=$(pycodestyle --max-line-length=120 ./hpobench)
    if [[ $test_codestyle ]]; then
      echo $test_codestyle
      exit 1
    else
      echo "Codesytle: No errors found"
    fi

    test_flake=$(flake8 --max-line-length=120 ./hpobench)
    if [[ $test_flake ]]; then
      echo $test_flake
      exit 1
    else
      echo "Flake8: No errors found"
    fi

    # Enable the error W0221: Parameters differ from overridden method (arguments-differ)
    pylint --disable=all --enable=W0221 ./hpobench
    exit_code=$?
    if [[ "$exit_code" -eq 0 ]]; then
        echo "Pylint: No signature errors found"
    else
        echo "Pylint: Signature Failure!"
        exit 1
    fi
else
    echo "Skip code style checking"
fi

#!/bin/bash

CONDA_ENV_NAME=$1
if [ -z "$CONDA_ENV_NAME" ]
then
    CONDA_RUN_COMMAND=
else
    CONDA_RUN_COMMAND="${CONDA_COMMAND} run ${CONDA_ENV_NAME}"
fi
DATA_PATH=$(python -c "from carps.objective_functions.mfpbench import MFPBENCH_TASK_DATA_DIR; print(MFPBENCH_TASK_DATA_DIR)")

if [ -z "$(ls -A $DATA_PATH)" ]; then
    echo "Directory is empty, proceeding with download."
else
    echo "Directory $DATA_PATH is not empty, skipping download."
    exit 0
fi
$CONDA_RUN_COMMAND python -m mfpbench download --status --data-dir $DATA_PATH
$CONDA_RUN_COMMAND python -m mfpbench download --benchmark pd1 --data-dir $DATA_PATH

#!/usr/bin/env sh

echo "Install Singularity"

sudo apt-get update && sudo apt-get install -y \
  build-essential \
  libssl-dev \
  uuid-dev \
  libgpgme11-dev \
  squashfs-tools \
  libseccomp-dev \
  wget \
  pkg-config \
  git \
  cryptsetup

if [[ "$SINGULARITY_VERSION" == "3.5" ]]; then
    export VERSION=3.5.3
elif [[ "$SINGULARITY_VERSION" == "3.6" ]]; then
    export VERSION=3.6.4
elif [[ "$SINGULARITY_VERSION" == "3.7" ]]; then
    export VERSION=3.7.3
elif [[ "$SINGULARITY_VERSION" == "3.8" ]]; then
    export VERSION=3.8.0
else
    echo "Skip installing Singularity"
fi

wget https://github.com/sylabs/singularity/archive/refs/tags/v${VERSION}.tar.gz && \
tar -xzf v${VERSION}.tar.gz && \
cd singularity-${VERSION} && \
./mconfig && \
make -C builddir && \
sudo make -C builddir install

cd ..
pip install .

#!/usr/bin/env sh

cd examples/container

for script in *.py
do
    python $script --on_travis
    rval=$?
    if [ "$rval" != 0 ]; then
        echo "Error running example $script"
        exit $rval
    fi
done

PIP=$PIP
if [ -z "$PIP" ]
then
    PIP="pip"
fi

$PIP install setuptools wheel jupyterlab conan build --upgrade
CATBOOST_SRC_ROOT="lib/catboost"
git clone https://github.com/catboost/catboost.git $CATBOOST_SRC_ROOT
mkdir -p lib/dists
python -m build \
    --sdist $CATBOOST_SRC_ROOT/catboost/python-package \
    --outdir lib/dists \
    --wheel      # --skip-dependency-check

PIP=$PIP

if [ -z "$PIP" ]
then
    PIP="pip"
fi

hebo_root="lib/HEBO"

# git clone https://github.com/huawei-noah/HEBO.git $hebo_root

> $hebo_root/HEBO/requirements.txt
$PIP install scipy --upgrade
$PIP install numpy pandas pymoo scikit-learn --upgrade
$PIP install gpytorch
$PIP install GPy
$PIP install numpy --upgrade

# # Install Catboost
# if [ ! -f "lib/dists/catboost-1.2.7.tar.gz" ]; then
#     echo "catboost source file does not exist at 'lib/dists/catboost-1.2.7.tar.gz'. Installing catboost from source (can take a while)."
#     . $hebo_root/install_catboost.sh
# fi
# $PIP install lib/dists/catboost-1.2.7.tar.gz

$PIP install setuptools wheel jupyterlab conan --upgrade
$PIP install catboost

# Install rest of the dependencies
$PIP install disjoint-set
$PIP install -e lib/HEBO/HEBO
$PIP install numpy --upgrade
$PIP install scipy --upgrade

#!/usr/bin/zsh

# This script is used to start all benchmark services in the container
# loop over all dirs in /opt/BencherBenchmarks and execute poetry run start-benchmark-service for each

for dir in ./*; do
    if [ -d "$dir" ]; then
        echo "Starting benchmark service for $dir"
        cd $dir
        #poetry run start-benchmark-service &
        bash -c "poetry install --no-root && poetry run start-benchmark-service &"
        cd ..
    fi
done

#!/bin/bash

CONDA_ENV_NAME=$1
PIP=$PIP

if [ -z "$PIP" ]
then
    PIP="pip"
fi
if [ -z "$CONDA_ENV_NAME" ]
then
    CONDA_RUN_COMMAND=
else
    CONDA_RUN_COMMAND="${CONDA_COMMAND} run ${CONDA_ENV_NAME}"
fi

CARPS_ROOT=$(python -c "from carps.utils.env_vars import CARPS_ROOT; print(CARPS_ROOT)")

git clone --branch fix/numpy_deprecation https://github.com/automl/HPOBench.git lib/HPOBench
$CONDA_RUN_COMMAND $PIP install lib/HPOBench
$CONDA_RUN_COMMAND $PIP install openml
$CONDA_RUN_COMMAND $PIP install ConfigSpace --upgrade
$CONDA_RUN_COMMAND python $CARPS_ROOT/container/recipes/benchmarks/HPOBench/prepare_nas_benchmarks.py

module load tools Apptainer

# Build container
# This is necessary because the specific container does not get built off the correct
# branch in HPOBench, thus the container in the registry does not work.
HPOBENCH_CONTAINER_DIR=$(python $CARPS_ROOT/container/recipes/benchmarks/HPOBench/get_container_dir.py)
echo "Building HPOBench container in $HPOBENCH_CONTAINER_DIR"
apptainer build --force $HPOBENCH_CONTAINER_DIR/ml_mmfb_0.0.1 lib/HPOBench/hpobench/container/recipes/ml/Singularity.ml_mmfb
echo "Built $HPOBENCH_CONTAINER_DIR/ml_mmfb_0.0.1"

apptainer build --force $HPOBENCH_CONTAINER_DIR/nasbench_201_0.0.5 lib/HPOBench/hpobench/container/recipes/nas/Singularity.nasbench_201
echo "Built $HPOBENCH_CONTAINER_DIR/nasbench_201_0.0.5"

# Credits


## Development

- Carolin Benjamins (Lead)
- Helena Graf
- Sarah Segel
- Difan Deng
- Tim Ruhkopf
- Leona Hennig
- Soham Basu
- Edward Bergman

## Contributors

None yet. Why not be the first?

# Installation

### Installation from PyPI

To install CARP-S, you can simply use `pip`:

1. Create virtual env with conda or uv

```bash
# Conda
conda create -n carps python=3.12
conda activate carps

# -OR -

# uv
pip install uv
export PIP="uv pip"  # Env var needed for Makefile commands
uv venv --python=3.12 carpsenv
source carpsenv/bin/activate
```

2. Install  carps.
```bash
pip install carps
```
### Installation from Source

If you want to install from source, you can clone the repository and install CARP-S via:

#### Conda
```bash
git clone https://github.com/AutoML/CARP-S.git
cd CARP-S
export PIP="pip"
conda create -n carps python=3.12
conda activate carps

# Install for usage
$PIP install .
```

#### uv
```bash
git clone https://github.com/AutoML/CARP-S.git
cd CARP-S
pip install uv
export PIP="uv pip"
uv venv --python=3.12 carpsenv
source carpsenv/bin/activate

# Install for usage
$PIP install .

# Install as editable
$PIP install -e .
```

If you want to install CARP-S for development, you can use the following command (from the root of the repo):
```bash
$PIP install -e .
python -m carps.build.make install-dev
```
#### Apptainer
⚠ This is still experimental.

You can also create a container with the env setup by running `apptainer build container/env.sif container/env.def`.
Then you can execute any carps commands as usual by add this prefix `apptainer exec container/env.sif` before the
command, e.g. `apptainer exec container/env.sif python -m carps.run +task/... +optimizer/...`.
There is also an sbatch script to run experiments from the database using the apptainer on a slurm cluster
(`sbatch scripts/container_run_from_db.sh`). You might need to adapt the array size and the number of repetitions
according to the number of experiments you can run.

PS.: On some clusters you might need to load the module apptainer like so `module load tools Apptainer`.
Troubleshooting: If you have problems writing your cache directory, mount-bind it like so
`apptainer shell --bind $XDG_CACHE_HOME container/env.sif`. This binds the directory `$XDG_CACHE_HOME` in the
container to the directory `$XDG_CACHE_HOME` on the host.
If you have problems with `/var/lib/hpobench`, this bind might help: 
`<hpobench data dir>:/var/lib/hpobench/data`. `<hpobench data dir>` can be found in
[`.hpobenchrc`](https://github.com/automl/HPOBench/?tab=readme-ov-file#configure-hpobench).

#### A note on python versions
For python3.12, numpy should be `numpy>=2.0.0`. For python3.10, numpy must be `numpy==1.26.4`, you can simply
`pip install numpy==1.26.4` after running the proposed install commands.

### Installing Benchmarks and Optimizers

Additionally, you need to install the requirements for the benchmark and optimizer that you want to use.

⚠ You can specify the directory of the task data by `export CARPS_TASK_DATA_DIR=...`. Please use absolute dirnames.
The default location is `<carps package location>/task_data`. If you specify a custom dir, always export the env var.
(The carps package location is the root of the package, not of the repo.)

For example, if you want to use the `SMAC3` optimizer and the `BBOB` benchmark, you need to install the
requirements for both of them via:

```bash
# Install options for optimizers and benchmarks (these are Makefile commands, check the Makefile at carps/build for
# more commands)
# The commands should be separated by a whitespace
python -m carps.build.make benchmark_bbob optimizer_smac
```
The benchmarks and optimizers can all be installed in one environment (tested with python3.12).

All possible install options for benchmarks are:
```
benchmark_bbob benchmark_hpobench benchmark_hpob benchmark_mfpbench benchmark_pymoo benchmark_yahpo
```
⚠ Some benchmarks require to download surrogate models and/or containers and thus might take disk space and time to
download.

All possible install options for optimizers are:
```
optimizer_smac optimizer_dehb optimizer_nevergrad optimizer_optuna optimizer_ax optimizer_skopt optimizer_synetune
```
All of the above except `optimizer_hebo` work with python3.12.

You can also install all benchmarks in one go with `benchmarks` and all optimizers with `optimizers`.
Check the `carps/build/Makefile` in carps for more details.

# Containers

!!! warning

    The usage of containers for benchmarking is still under development.


There are two main ways to use this framework:
1. Run everything in the same environment (e.g. to test locally)
2. Build separate Singularity/ Apptainer containers for the optimizer and the benchmark (e.g. to run on a cluster)

The first options can allow for faster development, but the second option is more robust and flexible since python or 
other package versions do not clash, and eases execution on e.g. a SLURM cluster.

The overall benchmarking system works as follows: 

There are three different containers wrapping different functionality and a shell script controlling these containers. 
The `HydraInitializer` container is responsible for constructing the Hydra configuration, 
which is required to initialize the `Optimizer` and the `Benchmark` container. 
The `Benchmark` container wraps the actual benchmark to be run and provides two main functionalities via a web service. 
First, it allows to get the search space associated with the benchmark. 
Second, it answers requests providing a configuration to be evaluated with the corresponding evaluation result.
The `Optimizer` container wraps the optimizer to be benchmarked and interacts with the `Benchmark` container.
Any information required to boot the containers is written to the hard drive by the `HydraInitializer` container. 

Note that we provide wrappers for the optimizer and the benchmark interfaces such that when you implement an 
optimizer or a benchmark within our benchmarking framework, 
you can ignore all aspects of the system just described and simply follow the simple API. 

![Overview of the whole process](../images/smac_benchmarking_containers.drawio.png)


### Installation
- Local: Install Apptainer
- Cluster: Configure Singularity/ Apptainer
- Setup Database if logging to to the database is required (mysql)

### Containerization
To run benchmarking with containers, both the optimizer and benchmark have to be wrapped separately. 
We use Singularity/ Apptainer for this purpose.
The following example illustrates the principle based on a `DummyOptimizer` and `DummyBenchmark`.

💡 You can check the location of the log files of your singularity instances with `singularity instance list -l`.

⚠ When creating recipes, take care that the paths are correct. In particular, check relative vs. absolute paths (e.g. benchmarking/... ❌ vs /benchmarking/... ✔).

💡 You can check the creation time and benchmarking version of a container with `singularity inspect <container>`. 
   To check the versions of the installed packages, you can use `singularity exec <container> pip freeze`.

#### Noctua2 Setup Before Compilation

Include the following lines in your `~/.bashrc`:

```bash
export SINGULARITY_CACHEDIR=$PC2PFS/hpc-prf-intexml/<USER>/.singularity_cache
export SINGULARITY_TMPDIR=/dev/shm/intexml<X>
mkdir /dev/shm/intexml<X> -p
```

#### Optimizer
A Singularity recipe has to be created for the optimizer, which should be saved in the folder `carps/container/recipes`.
This recipe has the purpose of setting up a container in which the optimizer can be run, e.g., installing the 
required packages, setting environment variables, copying files and so on.
For the `Dummy_Optimizer` this is `carps/container/recipes/dummy_optimizer/dummy_optimizer.recipe`, which you can consult 
as a basis for other optimizers.

The optimizer then has to be built to an image named after the optimizer id, e.g., `DUMMY_Optimizer.sif` for the
`DummyOptimizer` using the following command:

```bash
singularity build containers/optimizers/DUMMY_Optimizer.sif carps/container/recipes/optimizers/DUMMY_Optimizer/DUMMY_Optimizer.recipe
```

To facilitate this process, a short script is provided for this purpose, which is however system-specific to Noctua2.
It can be run as follows:

```bash
./compile_noctua2.sh containers/optimizers/DUMMY_Optimizer.sif carps/container/recipes/optimizers/DUMMY_Optimizer/DUMMY_Optimizer.recipe
```

#### Benchmark
Like for the optimizer, a Singularity recipe has to be created for the benchmark, which should be saved in the folder
`carps/container/recipes` as well.

The benchmark image also has to be according to the benchmark id, e.g., `DUMMY_ObjectiveFunction.sif` for the 
`DummyBenchmark` 
using
the following command:

```bash
singularity build containers/benchmarks/DUMMY_ObjectiveFunction.sif carps/container/recipes/benchmarks/DUMMY_ObjectiveFunction/DUMMY_ObjectiveFunction.recipe
```

Command for Noctua2:

```bash
./compile_noctua2.sh containers/benchmarks/DUMMY_ObjectiveFunction.sif carps/container/recipes/benchmarks/DUMMY_ObjectiveFunction/DUMMY_ObjectiveFunction.recipe
```

#### Running
A third container is needed that handles the hydra config. It does not need to be adjusted for each optimizer or
benchmark, but can be used as is. It can be built as follows:

```bash
singularity build containers/general/runner.sif carps/container/recipes/general/runner.recipe
```

Command for Noctua2:

```bash
./compile_noctua2.sh containers/general/runner.sif carps/container/recipes/general/runner.recipe
```

Running the containerized benchmarking system is also system-dependent. An example for Noctua2 is provided in the
script `start_container_noctua2.sh`. It can be run as follows:

```bash
./start_container_noctua2.sh
```

**NOTE**: This needs to be run in a SLURM-job, so either an interactive job

```bash
srun --cpus-per-task=2 -p normal --mem=2gb -n 1 --time=00:30:00 --pty bash
```

or a job allocated via script.

This will pull a job from the database and run it (database needs to be initialized beforehand).
To be efficient, this command should eventually be integrated into a SLURM script, which can be submitted to the
cluster (e.g. with job arrays).

# Hydra

In CARP-S, Hydra is used for handling the configuration of the benchmarking tasks
to be executed. 

Hydra is a Python framework that simplifies the development of complex applications by enabling 
their configuration to be dynamically composed and overridden, which is particularly useful 
for applications that require a high degree of customization and flexibility. 

For more information on Hydra, please refer to the 
[Hydra documentation](https://hydra.cc/docs/intro).

# First Steps

First, follow the [installation instructions](../installation.md) to install CARP-S. As described
in the installation guide, make sure to install the requirements for the benchmark and optimizer
you would like to run, e.g. `SMAC2.0` and `BBOB`.

Once the requirements for both an optimizer and a benchmark are installed, you can run one of 
the following minimal examples to benchmark `SMAC2.0` on `BBOB` directly with Hydra:

```bash
# Run SMAC BlackBoxFacade on certain BBOB task
python -m carps.run +optimizer/smac20=blackbox +task/BBOB=cfg_4_1_4_0 seed=1 task.optimization_resources.n_trials=25

# Run SMAC BlackBoxFacade on all available BBOB tasks for 10 seeds
python -m carps.run +optimizer/smac20=blackbox '+task/BBOB=glob(*)' 'seed=range(1,11)' -m
```

For the second command, the Hydra -m (or --multirun) option indicates that multiple runs will be 
performed over a range of parameter values. In this case, it's indicating that the benchmarking
should be run for all available BBOB tasks (+task/BBOB=glob(*)) and for 10 different 
seed values (seed=range(1,11)).

<img src="images/carps_Logo_wide.png" alt="Logo"/>

# CARP-S
Welcome to the CARP-S documentation.

!!! tip

    See the navigation links in the header or side-bars. Click the :octicons-three-bars-16: button (top left) on mobile.

For information on how to install CARP-S, please refer to the [installation instructions](installation.md).
To see an example of how to run a first optimizer on a benchmark, as well as a more comprehensive overview of what
CARP-S can offer, please refer to our [guides](guides/first-steps.md).
If you are interested in the commands that CARP-S provides, please refer to the [commands](commands.md).
To learn how to add your own optimizer or benchmark, or if you want to contribute to CARP-S in general, 
check out our [contributing](contributing/index.md) section.

# What is CARP-S?

CARP-S is a benchmarking framework for Comprehensive Automated Research Performance Studies, 
designed to evaluate multiple optimizers across various benchmark tasks. It aims to facilitate 
the development of effective and reliable methods for hyperparameter optimization (HPO).

-   :material-tune-vertical-variant: __Develop With Confidence__

    Developing optimizers is hard, evaluating them is harder and benchmarking
    against state-of-the-art is even harder. CARP-S provides a simple and easily extendable
    framework to develop, evaluate and benchmark **your** optimizer.

-   :material-arrow-all: __Various Scenarios__

    The benchmarks integrated in CARP-S offer tasks for blackbox, multi-fidelity, 
    multi-objective and multi-fidelity-multi-objective HPO, allowing you to evaluate
    your optimizer in a variety of scenarios.

-   :octicons-star-16: __Effective Evaluation__

    Fair comparisons between optimizers require evaluation on a large number of tasks, 
    which can be computationally infeasible. CARP-S provides a subset of representative 
    benchmarking tasks for each scenario to allow for effective evaluation.

-   :octicons-package-dependents-16: __Minimal Dependencies__

    CARP-S is modular and allows you to only install what you need to run and
    evaluate what you want. For details, please have a look at the
    [installation instructions](installation.md).

# Commands

## Default
### Run combo of task and optimizer
You can run a certain task and optimizer combination directly with Hydra via:
```bash
python -m carps.run +task=... +optimizer=... seed=... -m
```

### Check missing runs
To check whether any runs are missing, you can use the following command. It will create
a file `runcommands_missing.sh` containing the missing runs:
```bash
python -m carps.utils.check_missing <rundir>
```

### Gather data of runs
To collect all run data generated by the file logger into parquet files, use the following command:
```bash
python -m carps.analysis.gather_data <rundir>
```
The parquet files are then located in `<rundir>`. The `logs.csv` contain the trial info and values and 
the `logs_cfg.parquet` contain the experiment configuration.
The experiments can be matched via the column `experiment_id`.

## Database
### Fill the database with tasks
Another option is to fill the database with all possible combinations of tasks and optimizers
you would like to run:
```bash
python -m carps.container.create_cluster_configs +task=... +optimizer=... -m
```
### Run from database
Then, run them from the database with:
```bash
python -m carps.run_from_db 
```

### Show database statistics
```bash
python -m carps.experimenter.database.show_stats
```

### Reset experiments
Experiments with error status (or any other status) can be reset via:
- `python -m carps.experimenter.database.reset_experiments` for resetting all experiments with status error
- `python -m carps.experimenter.database.reset_experiments ['yahpo_attr_error']` for resetting experiments with
  this specific yahpo error condition.
- `python -m carps.experimenter.database.reset_experiments ['falsely_done']` for resetting experiments that are
  falsely marked as done (experiment ids not present in trials table).
- `python -m carps.experimenter.database.reset_experiments ['error', 'yahpo_attr_error', 'falsely_done']` for
    resetting all.

### Download results from database
```bash
python -m carps.experimenter.database.download_results
```

### Postprocess results from database
```bash
python -m carps.experimenter.database.process_logs
```

### Filelogs to database
If you ran experiments which logged to files, you can add them post-hoc to the database with the following command:
```bash
python -m carps.experimenter.scrape_results_to_db <rundir1> <rundir2>
```

# Contributing an Optimizer

To add a new optimizer to CARPS, you need to create a new Python file that defines a new optimizer 
class. This class should inherit from the `Optimizer` class defined in 
`carps/optimizers/optimizer.py`. You can have a look at the 
[optimizer template](https://github.com/automl/CARP-S-template/blob/main/my-optimizer.py) 
for inspiration.

Here's a step-by-step guide for how to add a new optimizer:

1. **Create a new Python file**: 
Create a new Python file in the `carps/optimizers/` directory.
For example, you might name it `my_optimizer.py`.


2. **Define your optimizer class**:
Define a new class that inherits from `Optimizer`. This class should implement the 
`convert_configspace` method, that takes a ConfigSpace configuration space and converts it to 
a search space from the optimizer, and a `convert_to_trial` method, that converts a proposal by 
the optimizer to a TrialInfo object. Furthermore, a `_setup_optimizer` method should be implemented,
setting up and returning the optimizer to be used, and a `get_current_incumbent` method, extracting 
the incumbent config and cost. Finally, an `ask` method is required, that 
queries a new trial to evaluate from the optimizer and returns it as a TrialInfo object, and a 
`tell` method, that takes a TrialInfo and TrialValue and updates the optimizer with the results of 
the trial. If your optimizer requires additional methods, you can implement them in your class. 


3. **Requirements file**: Create a requirements file and add the requirements for your optimizer.
   The file structure must be 
   `carps/container/recipes/optimizers/<optimizer_container_id>/<optimizer_container_id>_requirements.txt`,
   so for example, `carps/container/recipes/optimizers/my_optimizer/my_optimizer_requirements.txt`.

4. **Config files**: Add config files for the different optimizers under 
   `carps/configs/optimizer/my_optimizer/my_optimizer_config_{variant}.yaml`. 
   You can use the existing config files as a template.

Here's a basic example of what your `my_optimizer.py` file might look like:

```python
from ConfigSpace import Configuration, ConfigurationSpace
from carps.utils.trials import TrialInfo, TrialValue
from carps.optimizers.optimizer import Optimizer
from carps.loggers.abstract_logger import AbstractLogger
from carps.utils.types import Incumbent

class MyOptimizer(Optimizer):
    def __init__(
        self,
        task: Task,
        loggers: list[AbstractLogger] | None = None,
        expects_multiple_objectives: bool = False,  # noqa: FBT001, FBT002
        expects_fidelities: bool = False,  # noqa: FBT001, FBT002
    ) -> None:
        super().__init__(task, loggers, expects_multiple_objectives, expects_fidelities)
        # Initialize any additional attributes your optimizer needs here

    def convert_configspace(self, configspace: ConfigurationSpace) -> OptimizerSearchSpace:
        # Convert ConfigSpace configuration space to search space from optimizer.
        pass

    def convert_to_trial(self, optimizer_trial: OptimizerTrial) -> TrialInfo:
        # Convert proposal by optimizer to TrialInfo.
        pass

    def _setup_optimizer(self) -> Any:
        # Setup the optimizer.
        pass

    def get_current_incumbent(self) -> Incumbent:
        # Extract the incumbent config and cost.
        pass

    def ask(self) -> TrialInfo:
        # Ask the optimizer for a new trial to evaluate.
        pass

    def tell(self, trial_info: TrialInfo, trial_value: TrialValue) -> None:
        # Tell the optimizer a new trial.
        pass

    # Implement any additional methods your optimizer needs here
```

# Contributing
Contributions are welcome, and they are greatly appreciated! Every little bit
helps, and credit will always be given.

You can contribute in many ways:

## Types of Contributions

### Report Bugs

Report bugs at [https://github.com/automl/CARP-S/issues](https://github.com/automl/CARP-S/issues).

If you are reporting a bug, please include:

- Your operating system name and version.
- Any details about your local setup that might be helpful in troubleshooting.
- Detailed steps to reproduce the bug.

### Fix Bugs

Look through the GitHub issues for bugs. Anything tagged with "bug" and "help
wanted" is open to whoever wants to implement it.

### Implement Features

Look through the GitHub issues for features. Anything tagged with "enhancement"
and "help wanted" is open to whoever wants to implement it.

### Write Documentation

CARP-S could always use more documentation, whether as part of the
official CARP-S docs, in docstrings, or even on the web in blog posts,
articles, and such.

### Submit Feedback

The best way to send feedback is to file an issue at https://github.com/automl/CARP-S/issues.

If you are proposing a feature:

- Explain in detail how it would work.
- Keep the scope as narrow as possible, to make it easier to implement.
- Remember that this is a volunteer-driven project, and that contributions are welcome :)

## Get Started!

Ready to contribute? Here's how to set up `CARP-S` for local development.

Fork the `CARP-S` repo on GitHub and then clone your fork locally:
```bash
git clone git@github.com:YOUR_NAME_HERE/CARP-S.git
cd CARP-S
```

Install your local copy into a virtualenv.
We'll also install [`pre-commit`](https://pre-commit.com/) which runs some code quality checks.
```bash
python -m venv .venv
pip install -e ".[dev]"
pre-commit install
```

Create a branch for local development:
```bash
git checkout -b name-of-your-bugfix-or-feature
```

Now you can make your changes locally!

When you're done making changes, check that your changes pass ruff, including testing other Python versions:
```bash
python setup.py test or pytest
```
Commit your changes and push your branch to GitHub:

```bash
git add .
git commit -m "Your detailed description of your changes."
git push origin name-of-your-bugfix-or-feature
```
Submit a [pull request](https://github.com/automl/CARP-S/pulls) through the GitHub website!

## Local Development
To promote compatibility we encourage to enable `numpy>2.0.0` and `ConfigSpace>1.0.0`, and that in general modern
python versions are supported.
If there are still package clashes, you can create a virtual env per benchmark and optimizer.

## Pull Request Guidelines
Before you submit a pull request, check that it meets these guidelines:

1. The pull request should include tests.
2. If the pull request adds functionality, the docs should be updated.
Put your new functionality into a function with a docstring, and add the feature to the list in `README.md`.
3. The pull request should work for `Python 3.9` (ideally newer versions) and
make sure that the tests pass for all supported Python versions.

## Testing
To run a subset of tests:
```bash
pytest tests/some_file.py  # Run tests only in a certain file
pytest -k "test_mytest"  # Find tests with a name matching "test_mytest"
```

## Deploying
A reminder for the maintainers on how to deploy.
Make sure all your changes are committed (including an entry in `CHANGELOG.md`).

Update the version in `pyproject.toml`, then run:

```bash
git tag "x.y.z"  # Replace with your version
git push
git push --tags
```

# Large Scale Benchmarking

## Parallel
You can run your optimization via
```bash
python -m carps.run \
    +optimizer/randomsearch=config +task/DUMMY=config \
    'seed=range(1,11)' \
    +cluster=local -m
```
This uses joblib parallelization on your local machine.
If you are on a slurm cluster, you can specify `+cluster=slurm` and adapt this to your needs.
Check [this page for more launchers](https://hydra.cc/docs/plugins/joblib_launcher/), e.g. Ray or RQ besides Joblib and Submitit.

Blackbox tasks

1. YAHPO gym Set Single-Objective
```bash
SMAC20='+optimizer/smac20=blackbox'
SMAC14='+optimizer/smac14=blackbox'
RANDOMSEARCH='+optimizer/randomsearch=config'
HEBO='+optimizer/hebo=config'

YAHPO_SO='+task/YAHPO/SO=glob("cfg_*")'

SEED='seed=range(1,11)'


python carps/container/create_cluster_configs.py $SMAC20 $YAHPO_SO $SEED --multirun
python carps/container/create_cluster_configs.py $SMAC14 $YAHPO_SO $SEED --multirun
python carps/container/create_cluster_configs.py $OPTIMIZER $YAHPO_SO $SEED --multirun
python carps/container/create_cluster_configs.py $HEBO $YAHPO_SO $SEED --multirun

```


MF


fix/test multi-fidelity
overview experiments
create initial experiment set


PEACH
FISH:  framework for integrated scientific harvesting
CARP: comprehensive automl research platform

# Using Carps

In the case when you are developing your optimizer or benchmark in a standalone package, you can use carps without
directly working in the carps repo.

## With your own benchmark
For a custom benchmark we have an [example repo](https://github.com/automl/OptBench).
It shows how to use your own benchmark with carps optimizers.

## With your own optimizer
When you develop your own optimizer, check this [example repo](https://github.com/automl/CARP-S-example-optimizer).
It shows how to use your own optimizer with carps benchmarks.

# Contributing a Benchmark

To add a new objective function to CARP-S, you need to create a Python file that defines a 
new objective function class. This class should inherit from the `ObjectiveFunction` class defined in 
`carps/objective_functions/objective_function.py`. 
You can see an example of custom objective functions [in this repo](https://github.com/automl/OptBench).

Here's a step-by-step guide for how to add a new benchmark:

1. **Objective Function Python file**:
Create a new Python file in the `carps/objective_functions/` directory. 
For example, you might name it `my_objective_function.py`.


2. **Define your objective function class**: 
Define a new class that inherits from `ObjectiveFunction`. This class should implement the `configspace` 
property and the `_evaluate` method, as these are abstract in the base `ObjectiveFunction` class. 
The `configspace` property should return a `ConfigurationSpace` object that defines the 
configuration space for your objective function. The `_evaluate` method should take a `TrialInfo` object 
and return a `TrialValue` object. If your objective function requires additional methods, you can implement 
them in your class. For example, you might need a method to load data for your objective function. 


3. **Requirements file**: Create a requirements file and add the requirements for your benchmark. 
   The file structure must be 
   `carps/container/recipes/benchmarks/<benchmark_id>/<benchmark_id>_requirements.txt`, so for example,
   `carps/container/recipes/benchmarks/my_objective_function/my_objective_function_requirements.txt`. 

4. **Config files**: Add config files for the different tasks under 
   `carps/configs/task/my_objective_function/my_objective_function_config_{task}.yaml`. 
   You can use the existing config files as a template.

Here's a basic example of what your `my_objective_function.py` file might look like:

```python
from ConfigSpace import ConfigurationSpace
from carps.objective_functions.objective_function import ObjectiveFunction
from carps.utils.trials import TrialInfo, TrialValue

class MyObjectiveFunction(ObjectiveFunction):
    def __init__(self, loggers=None):
        super().__init__(loggers)
        # Initialize any additional attributes your objective function needs here

    @property
    def configspace(self) -> ConfigurationSpace:
        # Return a ConfigurationSpace object that defines the configuration space for your objective function
        pass

    def _evaluate(self, trial_info: TrialInfo) -> TrialValue:
        # Evaluate a trial and return a TrialValue object
        pass

    # Implement any additional methods your objective function needs here
```

# Database

Per default, `carps` logs to files. This has its caveats: Checking experiment status is a bit more cumbersome (but 
possible with `python -m carps.utils.check_missing <rundir>` to check for missing/failed experiments) and reading from
the filesystem takes a long time. For this reason, we can also control and log experiments to a MySQL database with
`PyExperimenter`.

This document describes how to set up the database for the CARP-S framework and use it for
logging experiment results and trajectories.

Either SQLite or MySQL can be used as database, which has some slight differences. 
Using SQLite is straightforward; you get a local database file but
parallel execution is not efficient at all. 

### Requirements and Configuration
Requirement: MySQL database is set up.

1. Add a `credentials.yaml` file in `carps/experimenter` with the following content:
```yaml
CREDENTIALS:
  Database:
      user: someuser
      password: amazing_password
  Connection:
      Standard:
        server: mysql_server
        port: 3306 (most likely)
```
2. Edit `carps/experimenter/py_experimenter.yaml` by setting:
```yaml
PY_EXPERIMENTER:
  n_jobs: 1

  Database:
    use_ssh_tunnel: false
    provider: mysql
    database: your_database_name
...
```

You configure the used database in the 
`carps/experimenter/py_experimenter.yaml` file by changing the `provider` to `mysql` or 
`sqlite`. 


!!! Note: If you use an ssh tunnel, set `use_ssh_tunnel` to `true` in `carps/experimenter/py_experimenter.yaml`.
Set up  `carps/experimenter/credentials.yaml` like this:
```yaml
CREDENTIALS:
  Database:
      user: someuser
      password: amazing_password
  Connection:
      Standard:
        server: mysql_server
        port: 3306 (most likely)
      Ssh:
        server: 127.0.0.1
        address: some_host  # hostname as specified in ~/.ssh/config
        # ssh_private_key_password: null
        # server: example.sshmysqlserver.com (address from ssh server)
        # address: example.sslserver.com
        # port: optional_ssh_port
        # remote_address: optional_mysql_server_address
        # remote_port: optional_mysql_server_port
        # local_address: optional_local_address
        # local_port: optional_local_port
        # passphrase: optional_ssh_passphrase
```
### Create Experiments
First, in order for PyExperimenter to be able to pull experiments from the database, we need to fill it.
The general command looks like this:
```bash
python -m carps.experimenter.create_cluster_configs +task=... +optimizer=... -m
```

This can be done locally or on the server if you can execute python there directly.
If you execute it locally, the database file `carps.db` will be created in the current directory and 
needs to be transferred to the cluster.
Example:
```bash
python carps/container/create_cluster_configs.py +optimizer/randomsearch=config +task/DUMMY=config 'seed=range(1,21)' -m
```
All subset runs were created with `scripts/create_experiments_in_db.sh`.

### Running Experiments
Now, execute experiments with:
```bash
python -m carps.run_from_db 'job_nr_dummy=range(1,1000)' -m
```
This will create 1000 multirun jobs, each pulling an experiment from PyExperimenter and executing it.

!!! Note: On most slurm clusters the max array size is 1000.
!!! Note: On our mysql server location, at most 300 connections at the same time are possible. You can limit your number
    of parallel jobs with `hydra.launcher.array_parallelism=250`.
!!! `carps/configs/runfromdb.yaml` configures the run and its resources. Currently defaults for our slurm cluster are
    configured. If you run on a different cluster, adapt `hydra.launcher`.

Experiments with error status (or any other status) can be reset via:
```bash
python -m carps.experimenter.database.reset_experiments
```

### Get the results from the database and post-process

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{init_local_config}
\alias{init_local_config}
\title{Initialize a local configuration}
\usage{
init_local_config(data_path = NULL, settings_path = "~/.config/yahpo_gym")
}
\arguments{
\item{data_path}{`character`\cr
Path to save meta-data to.}

\item{settings_path}{`character`\cr
Path to save configuration object including "path" to.}
}
\description{
Initialize a local configuration
}
\details{
Allows setting a path the required meta-data for YAHPO Gym is installed to.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BenchmarkSet.R
\name{BenchmarkSet}
\alias{BenchmarkSet}
\title{Benchmark Set}
\description{
Benchmark Set

Benchmark Set
}
\details{
R interface to a YAHPO Gym BenchmarkSet.


Allows exporting the objective function from a `YAHPO Gym` BenchmarkSet.
and additional helper functionality.
}
\section{Methods}{

  * new(key, onnx_session, active_session): Initialize the class.
  * get_objective(): Obtain the [`bbotk::Objective`].
  * get_opt_space_py(): Obtain the [`ConfigSpace`].
}

\section{Fields}{

  * session: [`onnx.InferenceSession`] \cr
  * instances: [`character`] \cr
}

\examples{
\dontrun{
b = BenchmarkSet$new("lcbench")
b$instances
}
}
\section{Public fields}{
\if{html}{\out{<div class="r6-fields">}}
\describe{
\item{\code{id}}{`character` \cr
The scenario identifier.}

\item{\code{instance}}{`character` \cr
The instance identifier.}

\item{\code{onnx_session}}{`onnxruntime.InferenceSession` \cr
A session to use for the predict. If `NULL` a new session is initialized.}

\item{\code{active_session}}{`logical` \cr
Should the benchmark run in an active `onnxruntime.InferenceSession`? Initialized to `FALSE`.}

\item{\code{multithread}}{`logical` \cr
Should the ONNX session be allowed to leverage multithreading capabilities?}

\item{\code{check}}{`logical` \cr
Check whether values coincide with `domain`.}

\item{\code{check_codomain}}{`logical` \cr
Check whether returned values coincide with `codomain`.}

\item{\code{noisy}}{`logical` \cr
Whether noisy surrogates should be used.}
}
\if{html}{\out{</div>}}
}
\section{Active bindings}{
\if{html}{\out{<div class="r6-active-bindings">}}
\describe{
\item{\code{session}}{`onnxruntime.InferenceSession` \cr
Set/Get the ONNX session.

The param `sess` is a `onnxruntime.InferenceSession`\cr
  A matching `onnxruntime.InferenceSession`. Please make sure
  that the session matches the selected benchmark scenario, as no
  additional checks are performed and inference will fail during
  evaluation of the objective function.}

\item{\code{instances}}{`character` \cr
A character vector of available instances for the scenario.}

\item{\code{domain}}{`ParamSet` \cr
A [`paradox::ParamSet`] describing the domain to be optimized over.}

\item{\code{codomain}}{`ParamSet` \cr
A [`paradox::ParamSet`] describing the output domain.}

\item{\code{quant}}{`numeric` \cr
Multiply runtime by this factor. Defaults to 0.01.}

\item{\code{py_instance}}{[`BenchmarkSet`] \cr
A python `yahpo_gym.BenchmarkSet`.}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-BenchmarkSet-new}{\code{BenchmarkSet$new()}}
\item \href{#method-BenchmarkSet-print}{\code{BenchmarkSet$print()}}
\item \href{#method-BenchmarkSet-get_objective}{\code{BenchmarkSet$get_objective()}}
\item \href{#method-BenchmarkSet-get_search_space}{\code{BenchmarkSet$get_search_space()}}
\item \href{#method-BenchmarkSet-get_opt_space_py}{\code{BenchmarkSet$get_opt_space_py()}}
\item \href{#method-BenchmarkSet-subset_codomain}{\code{BenchmarkSet$subset_codomain()}}
\item \href{#method-BenchmarkSet-clone}{\code{BenchmarkSet$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-BenchmarkSet-new"></a>}}
\if{latex}{\out{\hypertarget{method-BenchmarkSet-new}{}}}
\subsection{Method \code{new()}}{
Initialize a new object
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{BenchmarkSet$new(
  scenario,
  instance = NULL,
  onnx_session = NULL,
  active_session = FALSE,
  multithread = FALSE,
  check = FALSE,
  noisy = FALSE,
  check_codomain = FALSE
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{scenario}}{`character` \cr
Key for a benchmark scenario. See [`list_benchmarks`] for more information.}

\item{\code{instance}}{[`character`] \cr
A valid instance. See `instances`.}

\item{\code{onnx_session}}{`onnxruntime.InferenceSession` \cr
A matching `onnxruntime.InferenceSession`. See `session` for more information.
If no session is provided, new session is created.}

\item{\code{active_session}}{`logical` \cr
Should the benchmark run in an active `onnxruntime.InferenceSession`? Initialized to `FALSE`.}

\item{\code{multithread}}{`logical` \cr
Should the ONNX session be allowed to leverage multithreading capabilities? Default `FALSE`.}

\item{\code{check}}{`logical` \cr
Check inputs for validity before passing to surrogate model? Default `FALSE`.}

\item{\code{noisy}}{`logical` \cr
Should noisy surrogates be used instead of deterministic ones?}

\item{\code{check_codomain}}{`logical` \cr
Check outputs of surrogate model for validity? Default `FALSE`.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-BenchmarkSet-print"></a>}}
\if{latex}{\out{\hypertarget{method-BenchmarkSet-print}{}}}
\subsection{Method \code{print()}}{
Printer with some additional information.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{BenchmarkSet$print()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-BenchmarkSet-get_objective"></a>}}
\if{latex}{\out{\hypertarget{method-BenchmarkSet-get_objective}{}}}
\subsection{Method \code{get_objective()}}{
Get the objective function
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{BenchmarkSet$get_objective(
  instance,
  multifidelity = TRUE,
  check_values = TRUE,
  timed = FALSE,
  logging = FALSE,
  multithread = FALSE,
  seed = NULL,
  check_codomain = FALSE
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{instance}}{[`character`] \cr
A valid instance. See `instances`.}

\item{\code{multifidelity}}{(`logical`) \cr
Should the objective function respect multifidelity?
If `FALSE`, fidelity parameters are set as constants with their max fidelity in the domain.}

\item{\code{check_values}}{(`logical`) \cr
Should values be checked by bbotk? Initialized to `TRUE`.}

\item{\code{timed}}{(`logical`) \cr
Should function evaluation simulate runtime? Initialized to `FALSE`.}

\item{\code{logging}}{(`logical`) \cr
Should function evaluation be logged? Initialized to `FALSE`.}

\item{\code{multithread}}{`logical` \cr
Should the ONNX session be allowed to leverage multithreading capabilities? Default `FALSE`.}

\item{\code{seed}}{`integer` \cr
Initial seed for the `onnxruntime.runtime`. Only relevant if `noisy = TRUE`. Default `NULL` (no seed).}

\item{\code{check_codomain}}{`logical` \cr
Check outputs of surrogate model for validity? Default `FALSE`.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A [`Objective`][bbotk::Objective] containing "domain", "codomain" and a
 functionality to evaluate the surrogates.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-BenchmarkSet-get_search_space"></a>}}
\if{latex}{\out{\hypertarget{method-BenchmarkSet-get_search_space}{}}}
\subsection{Method \code{get_search_space()}}{
Get Optimization Search Space

A [`paradox::ParamSet`] describing the search_space used during optimization.
Typically, this is the same as the domain but, e.g., with some parameters on log scale.
This is the same space as the one returned by `get_opt_space_py` (with the instance param dropped).
Typically this search_space should be provided when creating an [bbotk::OptimInstance].
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{BenchmarkSet$get_search_space(
  drop_instance_param = TRUE,
  drop_fidelity_params = FALSE
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{drop_instance_param}}{[`logical`] \cr
Should the instance param (e.g., task id) be dropped? Defaults to `TRUE`.}

\item{\code{drop_fidelity_params}}{[`logical`] \cr
Should fidelity params be dropped? Defaults to `FALSE`.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A [`paradox::ParamSet`] containing the search space to optimize over.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-BenchmarkSet-get_opt_space_py"></a>}}
\if{latex}{\out{\hypertarget{method-BenchmarkSet-get_opt_space_py}{}}}
\subsection{Method \code{get_opt_space_py()}}{
Get Optimization ConfigSpace
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{BenchmarkSet$get_opt_space_py(drop_fidelity_params = TRUE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{drop_fidelity_params}}{[`logical`] \cr
Should fidelity params be dropped? Defaults to `TRUE`.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A configspace containing the search space to optimize over.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-BenchmarkSet-subset_codomain"></a>}}
\if{latex}{\out{\hypertarget{method-BenchmarkSet-subset_codomain}{}}}
\subsection{Method \code{subset_codomain()}}{
Subset the codomain. Sets a new domain.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{BenchmarkSet$subset_codomain(keep)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{keep}}{(`character`) \cr
Vector of co-domain target names to keep.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A [`paradox::ParamSet`] containing the output space (codomain).
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-BenchmarkSet-clone"></a>}}
\if{latex}{\out{\hypertarget{method-BenchmarkSet-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{BenchmarkSet$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\docType{package}
\name{yahpogym-package}
\alias{yahpogym}
\alias{yahpogym-package}
\title{yahpogym: Interface to the YAHPO Gym python module}
\description{
A package that connects YAHPO Gym to R.
}
\author{
\strong{Maintainer}: Florian Pfisterer \email{florian.pfisterer@stat.uni-muenchen.de}

Authors:
\itemize{
  \item Lennart Schneider \email{lennart.sch@web.de}
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_suites.R
\name{get_suites}
\alias{get_suites}
\title{Get versioned task sets}
\usage{
get_suites(type, version = 1)
}
\arguments{
\item{type}{[`character`] \cr
Type of task set to get. For now 'single' (single-crit) and 'multi' (multi-crit) are supported.}

\item{version}{[`numeric`] \cr
Version of the task set to get. Default is `1.0`.}
}
\value{
A data.frame containing a list of tasks.
}
\description{
Get Optimization ConfigSpace
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{list_benchmarks}
\alias{list_benchmarks}
\title{Print available benchmarks}
\usage{
list_benchmarks()
}
\value{
A [`Configuration`] (Python Object)
}
\description{
Print available benchmarks
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Objective.R
\name{preproc_xs}
\alias{preproc_xs}
\title{Preprocess r object for use with python's YAHPO Gym}
\usage{
preproc_xs(xss, ...)
}
\arguments{
\item{xss}{`list` of `list` \cr
List of hyperparams}

\item{...}{`any` \cr
Named params, appended to `xss`.}
}
\description{
Preprocess r object for use with python's YAHPO Gym
}
